!-----------------------------------------------
!            GDI+  06/08/03
!-----------------------------------------------
!        Win GDI API
!-----------------------------------------------

  OMIT('_EndOfInclude_',_GDIPLUS_)

_GDIPLUS_     EQUATE(1)  

!-----------------------------------------------
! GDI+ 
!-----------------------------------------------

! LF_FACESIZE  EQUATE(32) !   GDI Win API

!    A, R, G, B 

AlphaShift                                EQUATE(24)
RedShift                                  EQUATE(16)
GreenShift                                EQUATE(8)
BlueShift                                 EQUATE(0)

!     A, R, G, B 

AlphaMask                                 EQUATE(0FF000000h)
RedMask                                   EQUATE(0FF0000h)
GreenMask                                 EQUATE(0FF00h)
BlueMask                                  EQUATE(0FFh)

!  

PropertyTagTypeByte                       EQUATE(1)
PropertyTagTypeASCII                      EQUATE(2)
PropertyTagTypeShort                      EQUATE(3)
PropertyTagTypeLong                       EQUATE(4)
PropertyTagTypeRational                   EQUATE(5)
PropertyTagTypeUndefined                  EQUATE(7)
PropertyTagTypeSLONG                      EQUATE(9)
PropertyTagTypeSRational                  EQUATE(10)


! Image property ID tags

PropertyTagExifIFD                        EQUATE(08769h)
PropertyTagGpsIFD                         EQUATE(08825h)

PropertyTagNewSubfileType                 EQUATE(0FEh)
PropertyTagSubfileType                    EQUATE(0FFh)
PropertyTagImageWidth                     EQUATE(0100h)
PropertyTagImageHeight                    EQUATE(0101h)
PropertyTagBitsPerSample                  EQUATE(0102h)
PropertyTagCompression                    EQUATE(0103h)
PropertyTagPhotometricInterp              EQUATE(0106h)
PropertyTagThreshHolding                  EQUATE(0107h)
PropertyTagCellWidth                      EQUATE(0108h)
PropertyTagCellHeight                     EQUATE(0109h)
PropertyTagFillOrder                      EQUATE(010Ah)
PropertyTagDocumentName                   EQUATE(010Dh)
PropertyTagImageDescription               EQUATE(010Eh)
PropertyTagEquipMake                      EQUATE(010Fh)
PropertyTagEquipModel                     EQUATE(0110h)
PropertyTagStripOffsets                   EQUATE(0111h)
PropertyTagOrientation                    EQUATE(0112h)
PropertyTagSamplesPerPixel                EQUATE(0115h)
PropertyTagRowsPerStrip                   EQUATE(0116h)
PropertyTagStripBytesCount                EQUATE(0117h)
PropertyTagMinSampleValue                 EQUATE(0118h)
PropertyTagMaxSampleValue                 EQUATE(0119h)
PropertyTagXResolution                    EQUATE(011Ah)         ! Image resolution in width direction
PropertyTagYResolution                    EQUATE(011Bh)         ! Image resolution in height direction
PropertyTagPlanarConfig                   EQUATE(011Ch)         ! Image data arrangement
PropertyTagPageName                       EQUATE(011Dh)
PropertyTagXPosition                      EQUATE(011Eh)
PropertyTagYPosition                      EQUATE(011Fh)
PropertyTagFreeOffset                     EQUATE(0120h)
PropertyTagFreeByteCounts                 EQUATE(0121h)
PropertyTagGrayResponseUnit               EQUATE(0122h)
PropertyTagGrayResponseCurve              EQUATE(0123h)
PropertyTagT4Option                       EQUATE(0124h)
PropertyTagT6Option                       EQUATE(0125h)
PropertyTagResolutionUnit                 EQUATE(0128h)         ! Unit of X and Y resolution
PropertyTagPageNumber                     EQUATE(0129h)
PropertyTagTransferFuncition              EQUATE(012Dh)
PropertyTagSoftwareUsed                   EQUATE(0131h)
PropertyTagDateTime                       EQUATE(0132h)
PropertyTagArtist                         EQUATE(013Bh)
PropertyTagHostComputer                   EQUATE(013Ch)
PropertyTagPredictor                      EQUATE(013Dh)
PropertyTagWhitePoint                     EQUATE(013Eh)
PropertyTagPrimaryChromaticities          EQUATE(013Fh)
PropertyTagColorMap                       EQUATE(0140h)
PropertyTagHalftoneHints                  EQUATE(0141h)
PropertyTagTileWidth                      EQUATE(0142h)
PropertyTagTileLength                     EQUATE(0143h)
PropertyTagTileOffset                     EQUATE(0144h)
PropertyTagTileByteCounts                 EQUATE(0145h)
PropertyTagInkSet                         EQUATE(014Ch)
PropertyTagInkNames                       EQUATE(014Dh)
PropertyTagNumberOfInks                   EQUATE(014Eh)
PropertyTagDotRange                       EQUATE(0150h)
PropertyTagTargetPrinter                  EQUATE(0151h)
PropertyTagExtraSamples                   EQUATE(0152h)
PropertyTagSampleFormat                   EQUATE(0153h)
PropertyTagSMinSampleValue                EQUATE(0154h)
PropertyTagSMaxSampleValue                EQUATE(0155h)
PropertyTagTransferRange                  EQUATE(0156h)

PropertyTagJPEGProc                       EQUATE(0200h)
PropertyTagJPEGInterFormat                EQUATE(0201h)
PropertyTagJPEGInterLength                EQUATE(0202h)
PropertyTagJPEGRestartInterval            EQUATE(0203h)
PropertyTagJPEGLosslessPredictors         EQUATE(0205h)
PropertyTagJPEGPointTransforms            EQUATE(0206h)
PropertyTagJPEGQTables                    EQUATE(0207h)
PropertyTagJPEGDCTables                   EQUATE(0208h)
PropertyTagJPEGACTables                   EQUATE(0209h)

PropertyTagYCbCrCoefficients              EQUATE(0211h)
PropertyTagYCbCrSubsampling               EQUATE(0212h)
PropertyTagYCbCrPositioning               EQUATE(0213h)
PropertyTagREFBlackWhite                  EQUATE(0214h)

PropertyTagICCProfile                     EQUATE(08773h)            ! This TAG is defined by ICC for embedded ICC in TIFF
PropertyTagGamma                          EQUATE(0301h)
PropertyTagICCProfileDescriptor           EQUATE(0302h)
PropertyTagSRGBRenderingIntent            EQUATE(0303h)

PropertyTagImageTitle                     EQUATE(0320h)
PropertyTagCopyright                      EQUATE(08298h)

! Extra TAGs (Like Adobe Image Information tags etc.)

PropertyTagResolutionXUnit                EQUATE(05001h)
PropertyTagResolutionYUnit                EQUATE(05002h)
PropertyTagResolutionXLengthUnit          EQUATE(05003h)
PropertyTagResolutionYLengthUnit          EQUATE(05004h)
PropertyTagPrintFlags                     EQUATE(05005h)
PropertyTagPrintFlagsVersion              EQUATE(05006h)
PropertyTagPrintFlagsCrop                 EQUATE(05007h)
PropertyTagPrintFlagsBleedWidth           EQUATE(05008h)
PropertyTagPrintFlagsBleedWidthScale      EQUATE(05009h)
PropertyTagHalftoneLPI                    EQUATE(0500Ah)
PropertyTagHalftoneLPIUnit                EQUATE(0500Bh)
PropertyTagHalftoneDegree                 EQUATE(0500Ch)
PropertyTagHalftoneShape                  EQUATE(0500Dh)
PropertyTagHalftoneMisc                   EQUATE(0500Eh)
PropertyTagHalftoneScreen                 EQUATE(0500Fh)
PropertyTagJPEGQuality                    EQUATE(05010h)
PropertyTagGridSize                       EQUATE(05011h)
PropertyTagThumbnailFormat                EQUATE(05012h)        ! 1 EQUATE(JPEG, 0 EQUATE(RAW RGB
PropertyTagThumbnailWidth                 EQUATE(05013h)
PropertyTagThumbnailHeight                EQUATE(05014h)
PropertyTagThumbnailColorDepth            EQUATE(05015h)
PropertyTagThumbnailPlanes                EQUATE(05016h)
PropertyTagThumbnailRawBytes              EQUATE(05017h)
PropertyTagThumbnailSize                  EQUATE(05018h)
PropertyTagThumbnailCompressedSize        EQUATE(05019h)
PropertyTagColorTransferFunction          EQUATE(0501Ah)
PropertyTagThumbnailData                  EQUATE(0501Bh)        ! RAW thumbnail bits in JPEG format or RGB format
                                                                ! depends on PropertyTagThumbnailFormat
! Thumbnail related TAGs

PropertyTagThumbnailImageWidth            EQUATE(05020h)        ! Thumbnail width
PropertyTagThumbnailImageHeight           EQUATE(05021h)        ! Thumbnail height
PropertyTagThumbnailBitsPerSample         EQUATE(05022h)        ! Number of bits per component
PropertyTagThumbnailCompression           EQUATE(05023h)        ! Compression Scheme
PropertyTagThumbnailPhotometricInterp     EQUATE(05024h)        ! Pixel composition
PropertyTagThumbnailImageDescription      EQUATE(05025h)        ! Image Tile
PropertyTagThumbnailEquipMake             EQUATE(05026h)        ! Manufacturer of Image Input equipment
PropertyTagThumbnailEquipModel            EQUATE(05027h)        ! Model of Image input equipment
PropertyTagThumbnailStripOffsets          EQUATE(05028h)        ! Image data location
PropertyTagThumbnailOrientation           EQUATE(05029h)        ! Orientation of image
PropertyTagThumbnailSamplesPerPixel       EQUATE(0502Ah)        ! Number of components
PropertyTagThumbnailRowsPerStrip          EQUATE(0502Bh)        ! Number of rows per strip
PropertyTagThumbnailStripBytesCount       EQUATE(0502Ch)        ! Bytes per compressed strip
PropertyTagThumbnailResolutionX           EQUATE(0502Dh)        ! Resolution in width direction
PropertyTagThumbnailResolutionY           EQUATE(0502Eh)        ! Resolution in height direction
PropertyTagThumbnailPlanarConfig          EQUATE(0502Fh)        ! Image data arrangement
PropertyTagThumbnailResolutionUnit        EQUATE(05030h)        ! Unit of X and Y Resolution
PropertyTagThumbnailTransferFunction      EQUATE(05031h)        ! Transfer function
PropertyTagThumbnailSoftwareUsed          EQUATE(05032h)        ! Software used
PropertyTagThumbnailDateTime              EQUATE(05033h)        ! File change date and time
PropertyTagThumbnailArtist                EQUATE(05034h)        ! Person who created the image
PropertyTagThumbnailWhitePoint            EQUATE(05035h)        ! White point chromaticity
PropertyTagThumbnailPrimaryChromaticities EQUATE(05036h)        ! Chromaticities of primaries
PropertyTagThumbnailYCbCrCoefficients     EQUATE(05037h)        ! Color space transformation coefficients
PropertyTagThumbnailYCbCrSubsampling      EQUATE(05038h)        ! Subsampling ratio of Y to C
PropertyTagThumbnailYCbCrPositioning      EQUATE(05039h)        ! Y and C position
PropertyTagThumbnailRefBlackWhite         EQUATE(0503Ah)        ! Pair of black and white reference values
PropertyTagThumbnailCopyRight             EQUATE(0503Bh)        ! CopyRight holder

PropertyTagLuminanceTable                 EQUATE(05090h)
PropertyTagChrominanceTable               EQUATE(05091h)

PropertyTagFrameDelay                     EQUATE(05100h)
PropertyTagLoopCount                      EQUATE(05101h)

PropertyTagPixelUnit                      EQUATE(05110h)        ! Unit specifier for pixel/unit
PropertyTagPixelPerUnitX                  EQUATE(05111h)        ! Pixels per unit in X
PropertyTagPixelPerUnitY                  EQUATE(05112h)        ! Pixels per unit in Y
PropertyTagPaletteHistogram               EQUATE(05113h)        ! Palette histogram

! EXIF specific tag

PropertyTagExifExposureTime               EQUATE(0829Ah)
PropertyTagExifFNumber                    EQUATE(0829Dh)

PropertyTagExifExposureProg               EQUATE(08822h)
PropertyTagExifSpectralSense              EQUATE(08824h)
PropertyTagExifISOSpeed                   EQUATE(08827h)
PropertyTagExifOECF                       EQUATE(08828h)

PropertyTagExifVer                        EQUATE(09000h)
PropertyTagExifDTOrig                     EQUATE(09003h)       ! Date & time of original
PropertyTagExifDTDigitized                EQUATE(09004h)       ! Date & time of digital data generation

PropertyTagExifCompConfig                 EQUATE(09101h)
PropertyTagExifCompBPP                    EQUATE(09102h)

PropertyTagExifShutterSpeed               EQUATE(09201h)
PropertyTagExifAperture                   EQUATE(09202h)
PropertyTagExifBrightness                 EQUATE(09203h)
PropertyTagExifExposureBias               EQUATE(09204h)
PropertyTagExifMaxAperture                EQUATE(09205h)
PropertyTagExifSubjectDist                EQUATE(09206h)
PropertyTagExifMeteringMode               EQUATE(09207h)
PropertyTagExifLightSource                EQUATE(09208h)
PropertyTagExifFlash                      EQUATE(09209h)
PropertyTagExifFocalLength                EQUATE(0920Ah)
PropertyTagExifMakerNote                  EQUATE(0927Ch)
PropertyTagExifUserComment                EQUATE(09286h)
PropertyTagExifDTSubsec                   EQUATE(09290h)    ! Date & Time subseconds
PropertyTagExifDTOrigSS                   EQUATE(09291h)    ! Date & Time original subseconds
PropertyTagExifDTDigSS                    EQUATE(09292h)    ! Date & TIme digitized subseconds

PropertyTagExifFPXVer                     EQUATE(0A000h)
PropertyTagExifColorSpace                 EQUATE(0A001h)
PropertyTagExifPixXDim                    EQUATE(0A002h)
PropertyTagExifPixYDim                    EQUATE(0A003h)
PropertyTagExifRelatedWav                 EQUATE(0A004h)    ! related sound file
PropertyTagExifInterop                    EQUATE(0A005h)
PropertyTagExifFlashEnergy                EQUATE(0A20Bh)
PropertyTagExifSpatialFR                  EQUATE(0A20Ch)    ! Spatial Frequency Response
PropertyTagExifFocalXRes                  EQUATE(0A20Eh)    ! Focal Plane X Resolution
PropertyTagExifFocalYRes                  EQUATE(0A20Fh)    ! Focal Plane Y Resolution
PropertyTagExifFocalResUnit               EQUATE(0A210h)    ! Focal Plane Resolution Unit
PropertyTagExifSubjectLoc                 EQUATE(0A214h)
PropertyTagExifExposureIndex              EQUATE(0A215h)
PropertyTagExifSensingMethod              EQUATE(0A217h)
PropertyTagExifFileSource                 EQUATE(0A300h)
PropertyTagExifSceneType                  EQUATE(0A301h)
PropertyTagExifCfaPattern                 EQUATE(0A302h)

PropertyTagGpsVer                         EQUATE(00h)
PropertyTagGpsLatitudeRef                 EQUATE(01h)
PropertyTagGpsLatitude                    EQUATE(02h)
PropertyTagGpsLongitudeRef                EQUATE(03h)
PropertyTagGpsLongitude                   EQUATE(04h)
PropertyTagGpsAltitudeRef                 EQUATE(05h)
PropertyTagGpsAltitude                    EQUATE(06h)
PropertyTagGpsGpsTime                     EQUATE(07h)
PropertyTagGpsGpsSatellites               EQUATE(08h)
PropertyTagGpsGpsStatus                   EQUATE(09h)
PropertyTagGpsGpsMeasureMode              EQUATE(0Ah)
PropertyTagGpsGpsDop                      EQUATE(0Bh)       ! Measurement precision
PropertyTagGpsSpeedRef                    EQUATE(0Ch)
PropertyTagGpsSpeed                       EQUATE(0Dh)
PropertyTagGpsTrackRef                    EQUATE(0Eh)
PropertyTagGpsTrack                       EQUATE(0Fh)
PropertyTagGpsImgDirRef                   EQUATE(010h)
PropertyTagGpsImgDir                      EQUATE(011h)
PropertyTagGpsMapDatum                    EQUATE(012h)
PropertyTagGpsDestLatRef                  EQUATE(013h)
PropertyTagGpsDestLat                     EQUATE(014h)
PropertyTagGpsDestLongRef                 EQUATE(015h)
PropertyTagGpsDestLong                    EQUATE(016h)
PropertyTagGpsDestBearRef                 EQUATE(017h)
PropertyTagGpsDestBear                    EQUATE(018h)
PropertyTagGpsDestDistRef                 EQUATE(019h)
PropertyTagGpsDestDist                    EQUATE(01Ah)

! TODO: Make a function to get these GUIDs
! CLSIDs (aka GUIDs) used with the GdipGetImageRawFormat function:

! DEFINE_GUID(ImageFormatUndefined, 0xb96b3ca9,0x0728,0x11d3,0x9d,0x7b,0x00,0x00,0xf8,0x1e,0xf3,0x2e)
! DEFINE_GUID(ImageFormatMemoryBMP, 0xb96b3caa,0x0728,0x11d3,0x9d,0x7b,0x00,0x00,0xf8,0x1e,0xf3,0x2e)
! DEFINE_GUID(ImageFormatBMP,       0xb96b3cab,0x0728,0x11d3,0x9d,0x7b,0x00,0x00,0xf8,0x1e,0xf3,0x2e)
! DEFINE_GUID(ImageFormatEMF,       0xb96b3cac,0x0728,0x11d3,0x9d,0x7b,0x00,0x00,0xf8,0x1e,0xf3,0x2e)
! DEFINE_GUID(ImageFormatWMF,       0xb96b3cad,0x0728,0x11d3,0x9d,0x7b,0x00,0x00,0xf8,0x1e,0xf3,0x2e)
! DEFINE_GUID(ImageFormatJPEG,      0xb96b3cae,0x0728,0x11d3,0x9d,0x7b,0x00,0x00,0xf8,0x1e,0xf3,0x2e)
! DEFINE_GUID(ImageFormatPNG,       0xb96b3caf,0x0728,0x11d3,0x9d,0x7b,0x00,0x00,0xf8,0x1e,0xf3,0x2e)
! DEFINE_GUID(ImageFormatGIF,       0xb96b3cb0,0x0728,0x11d3,0x9d,0x7b,0x00,0x00,0xf8,0x1e,0xf3,0x2e)
! DEFINE_GUID(ImageFormatTIFF,      0xb96b3cb1,0x0728,0x11d3,0x9d,0x7b,0x00,0x00,0xf8,0x1e,0xf3,0x2e)
! DEFINE_GUID(ImageFormatEXIF,      0xb96b3cb2,0x0728,0x11d3,0x9d,0x7b,0x00,0x00,0xf8,0x1e,0xf3,0x2e)
! DEFINE_GUID(ImageFormatIcon,      0xb96b3cb5,0x0728,0x11d3,0x9d,0x7b,0x00,0x00,0xf8,0x1e,0xf3,0x2e)

!-----------------------------------------------
!            GDI+ Enums
!-----------------------------------------------

Enum:GpUnit             EQUATE(LONG)
!-----------------------------------
GpUnit ITEMIZE(0)
gpUnitWorld             EQUATE  ! 0 -- World coordinate (non-physical unit)
gpUnitDisplay           EQUATE  ! 1 -- Variable -- for PageTransform only
gpUnitPixel             EQUATE  ! 2 -- Each unit is one device pixel.
gpUnitPoint             EQUATE  ! 3 -- Each unit is a printer's point, or 1/72 inch.
gpUnitInch              EQUATE  ! 4 -- Each unit is 1 inch.
gpUnitDocument          EQUATE  ! 5 -- Each unit is 1/300 inch.
gpUnitMillimeter        EQUATE  ! 6 -- Each unit is 1 millimeter.
 END


Enum:Colors             EQUATE(LONG)
!-----------------------------------
Colors ITEMIZE
gpAliceBlue             EQUATE(0FFF0F8FFh)
gpAntiqueWhite          EQUATE(0FFFAEBD7h)
gpAqua                  EQUATE(0FF00FFFFh)
gpAquamarine            EQUATE(0FF7FFFD4h)
gpAzure                 EQUATE(0FFF0FFFFh)
gpBeige                 EQUATE(0FFF5F5DCh)
gpBisque                EQUATE(0FFFFE4C4h)
gpBlack                 EQUATE(0FF000000h)
gpBlanchedAlmond        EQUATE(0FFFFEBCDh)
gpBlue                  EQUATE(0FF0000FFh)
gpBlueViolet            EQUATE(0FF8A2BE2h)
gpBrown                 EQUATE(0FFA52A2Ah)
gpBurlyWood             EQUATE(0FFDEB887h)
gpCadetBlue             EQUATE(0FF5F9EA0h)
gpChartreuse            EQUATE(0FF7FFF00h)
gpChocolate             EQUATE(0FFD2691Eh)
gpCoral                 EQUATE(0FFFF7F50h)
gpCornflowerBlue        EQUATE(0FF6495EDh)
gpCornsilk              EQUATE(0FFFFF8DCh)
gpCrimson               EQUATE(0FFDC143Ch)
gpCyan                  EQUATE(0FF00FFFFh)
gpDarkBlue              EQUATE(0FF00008Bh)
gpDarkCyan              EQUATE(0FF008B8Bh)
gpDarkGoldenrod         EQUATE(0FFB8860Bh)
gpDarkGray              EQUATE(0FFA9A9A9h)
gpDarkGreen             EQUATE(0FF006400h)
gpDarkKhaki             EQUATE(0FFBDB76Bh)
gpDarkMagenta           EQUATE(0FF8B008Bh)
gpDarkOliveGreen        EQUATE(0FF556B2Fh)
gpDarkOrange            EQUATE(0FFFF8C00h)
gpDarkOrchid            EQUATE(0FF9932CCh)
gpDarkRed               EQUATE(0FF8B0000h)
gpDarkSalmon            EQUATE(0FFE9967Ah)
gpDarkSeaGreen          EQUATE(0FF8FBC8Bh)
gpDarkSlateBlue         EQUATE(0FF483D8Bh)
gpDarkSlateGray         EQUATE(0FF2F4F4Fh)
gpDarkTurquoise         EQUATE(0FF00CED1h)
gpDarkViolet            EQUATE(0FF9400D3h)
gpDeepPink              EQUATE(0FFFF1493h)
gpDeepSkyBlue           EQUATE(0FF00BFFFh)
gpDimGray               EQUATE(0FF696969h)
gpDodgerBlue            EQUATE(0FF1E90FFh)
gpFirebrick             EQUATE(0FFB22222h)
gpFloralWhite           EQUATE(0FFFFFAF0h)
gpForestGreen           EQUATE(0FF228B22h)
gpFuchsia               EQUATE(0FFFF00FFh)
gpGainsboro             EQUATE(0FFDCDCDCh)
gpGhostWhite            EQUATE(0FFF8F8FFh)
gpGold                  EQUATE(0FFFFD700h)
gpGoldenrod             EQUATE(0FFDAA520h)
gpGray                  EQUATE(0FF808080h)
gpGreen                 EQUATE(0FF008000h)
gpGreenYellow           EQUATE(0FFADFF2Fh)
gpHoneydew              EQUATE(0FFF0FFF0h)
gpHotPink               EQUATE(0FFFF69B4h)
gpIndianRed             EQUATE(0FFCD5C5Ch)
gpIndigo                EQUATE(0FF4B0082h)
gpIvory                 EQUATE(0FFFFFFF0h)
gpKhaki                 EQUATE(0FFF0E68Ch)
gpLavender              EQUATE(0FFE6E6FAh)
gpLavenderBlush         EQUATE(0FFFFF0F5h)
gpLawnGreen             EQUATE(0FF7CFC00h)
gpLemonChiffon          EQUATE(0FFFFFACDh)
gpLightBlue             EQUATE(0FFADD8E6h)
gpLightCoral            EQUATE(0FFF08080h)
gpLightCyan             EQUATE(0FFE0FFFFh)
gpLightGoldenrodYellow  EQUATE(0FFFAFAD2h)
gpLightGray             EQUATE(0FFD3D3D3h)
gpLightGreen            EQUATE(0FF90EE90h)
gpLightPink             EQUATE(0FFFFB6C1h)
gpLightSalmon           EQUATE(0FFFFA07Ah)
gpLightSeaGreen         EQUATE(0FF20B2AAh)
gpLightSkyBlue          EQUATE(0FF87CEFAh)
gpLightSlateGray        EQUATE(0FF778899h)
gpLightSteelBlue        EQUATE(0FFB0C4DEh)
gpLightYellow           EQUATE(0FFFFFFE0h)
gpLime                  EQUATE(0FF00FF00h)
gpLimeGreen             EQUATE(0FF32CD32h)
gpLinen                 EQUATE(0FFFAF0E6h)
gpMagenta               EQUATE(0FFFF00FFh)
gpMaroon                EQUATE(0FF800000h)
gpMediumAquamarine      EQUATE(0FF66CDAAh)
gpMediumBlue            EQUATE(0FF0000CDh)
gpMediumOrchid          EQUATE(0FFBA55D3h)
gpMediumPurple          EQUATE(0FF9370DBh)
gpMediumSeaGreen        EQUATE(0FF3CB371h)
gpMediumSlateBlue       EQUATE(0FF7B68EEh)
gpMediumSpringGreen     EQUATE(0FF00FA9Ah)
gpMediumTurquoise       EQUATE(0FF48D1CCh)
gpMediumVioletRed       EQUATE(0FFC71585h)
gpMidnightBlue          EQUATE(0FF191970h)
gpMintCream             EQUATE(0FFF5FFFAh)
gpMistyRose             EQUATE(0FFFFE4E1h)
gpMoccasin              EQUATE(0FFFFE4B5h)
gpNavajoWhite           EQUATE(0FFFFDEADh)
gpNavy                  EQUATE(0FF000080h)
gpOldLace               EQUATE(0FFFDF5E6h)
gpOlive                 EQUATE(0FF808000h)
gpOliveDrab             EQUATE(0FF6B8E23h)
gpOrange                EQUATE(0FFFFA500h)
gpOrangeRed             EQUATE(0FFFF4500h)
gpOrchid                EQUATE(0FFDA70D6h)
gpPaleGoldenrod         EQUATE(0FFEEE8AAh)
gpPaleGreen             EQUATE(0FF98FB98h)
gpPaleTurquoise         EQUATE(0FFAFEEEEh)
gpPaleVioletRed         EQUATE(0FFDB7093h)
gpPapayaWhip            EQUATE(0FFFFEFD5h)
gpPeachPuff             EQUATE(0FFFFDAB9h)
gpPeru                  EQUATE(0FFCD853Fh)
gpPink                  EQUATE(0FFFFC0CBh)
gpPlum                  EQUATE(0FFDDA0DDh)
gpPowderBlue            EQUATE(0FFB0E0E6h)
gpPurple                EQUATE(0FF800080h)
gpRed                   EQUATE(0FFFF0000h)
gpRosyBrown             EQUATE(0FFBC8F8Fh)
gpRoyalBlue             EQUATE(0FF4169E1h)
gpSaddleBrown           EQUATE(0FF8B4513h)
gpSalmon                EQUATE(0FFFA8072h)
gpSandyBrown            EQUATE(0FFF4A460h)
gpSeaGreen              EQUATE(0FF2E8B57h)
gpSeaShell              EQUATE(0FFFFF5EEh)
gpSienna                EQUATE(0FFA0522Dh)
gpSilver                EQUATE(0FFC0C0C0h)
gpSkyBlue               EQUATE(0FF87CEEBh)
gpSlateBlue             EQUATE(0FF6A5ACDh)
gpSlateGray             EQUATE(0FF708090h)
gpSnow                  EQUATE(0FFFFFAFAh)
gpSpringGreen           EQUATE(0FF00FF7Fh)
gpSteelBlue             EQUATE(0FF4682B4h)
gpTan                   EQUATE(0FFD2B48Ch)
gpTeal                  EQUATE(0FF008080h)
gpThistle               EQUATE(0FFD8BFD8h)
gpTomato                EQUATE(0FFFF6347h)
gpGpTransparent         EQUATE(0FFFFFFh)
gpTurquoise             EQUATE(0FF40E0D0h)
gpViolet                EQUATE(0FFEE82EEh)
gpWheat                 EQUATE(0FFF5DEB3h)
gpWhite                 EQUATE(0FFFFFFFFh)
gpWhiteSmoke            EQUATE(0FFF5F5F5h)
gpYellow                EQUATE(0FFFFFF00h)
gpYellowGreen           EQUATE(0FF9ACD32h)
 END


Enum:GpStatus           EQUATE(LONG)
!--------------------------------------
GpStatus ITEMIZE(0)
gpOk                        EQUATE ! 0
gpGenericError              EQUATE ! 1
gpInvalidParameter          EQUATE ! 2
gpOutOfMemory               EQUATE ! 3
gpObjectBusy                EQUATE ! 4
gpInsufficientBuffer        EQUATE ! 5
gpNotImplemented            EQUATE ! 6
gpWin32Error                EQUATE ! 7
gpWrongState                EQUATE ! 8
gpAborted                   EQUATE ! 9
gpFileNotFound              EQUATE ! 10
gpValueOverflow             EQUATE ! 11
gpAccessDenied              EQUATE ! 12
gpUnknownImageFormat        EQUATE ! 13
gpFontFamilyNotFound        EQUATE ! 14
gpFontStyleNotFound         EQUATE ! 15
gpNotTrueTypeFont           EQUATE ! 16
gpUnsupportedGdiplusVersion EQUATE ! 17
gpGdiplusNotInitialized     EQUATE ! 18
gpPropertyNotFound          EQUATE ! 19
gpPropertyNotSupported      EQUATE ! 20
  END


Enum:QualityMode          EQUATE(LONG)
!--------------------------------------
QualityMode ITEMIZE
QualityModeInvalid        EQUATE(-1)
QualityModeDefault        EQUATE(0)
QualityModeLow            EQUATE(1)       ! Best performance
QualityModeHigh           EQUATE(2)       ! Best rendering quality
 END

Enum:CompositingMode       EQUATE(LONG)   ! Alpha Compositing mode constants
!--------------------------------------
CompositingMode  ITEMIZE(0)
CompositingModeSourceOver  EQUATE  ! 0
CompositingModeSourceCopy  EQUATE  ! 1
   END


Enum:CompositingQuality       EQUATE(LONG) ! Alpha Compositing quality constants
!----------------------------------------
CompositingQuality  ITEMIZE
CompositingQualityInvalid        EQUATE(-1)
CompositingQualityDefault        EQUATE(0)
CompositingQualityHighSpeed      EQUATE(1)
CompositingQualityHighQuality    EQUATE(2)
CompositingQualityGammaCorrected EQUATE(3)
CompositingQualityAssumeLinear   EQUATE(4)
  END


Enum:GenericFontFamily           EQUATE(LONG)  ! Generic font families
!----------------------------------------
GenericFontFamily ITEMIZE(0)
GenericFontFamilySerif           EQUATE
GenericFontFamilySansSerif       EQUATE
GenericFontFamilyMonospace       EQUATE
  END

Enum:FontStyle       EQUATE(LONG)  ! FontStyle: face types and common styles
!---------------------------------------
FontStyle  ITEMIZE
FontStyleRegular                 EQUATE(0)
FontStyleBold                    EQUATE(1)
FontStyleItalic                  EQUATE(2)
FontStyleBoldItalic              EQUATE(3)
FontStyleUnderline               EQUATE(4)
FontStyleStrikeout               EQUATE(8)
   END

Enum:SmoothingMode               EQUATE(LONG)
!-------------------------------------
SmoothingMode ITEMIZE
SmoothingModeInvalid             EQUATE(-1)
SmoothingModeDefault             EQUATE(0)
SmoothingModeHighSpeed           EQUATE(1)
SmoothingModeHighQuality         EQUATE(2)
SmoothingModeNone                EQUATE(3)
SmoothingModeAntiAlias           EQUATE(4)
   END

Enum:FillMode                    EQUATE(LONG)
!----------------------------------
FillMode ITEMIZE(0)
FillModeAlternate                EQUATE  ! 0
FillModeWinding                  EQUATE  ! 1
   END

Enum:InterpolationMode                 EQUATE(LONG)
!-----------------------------------------------
InterpolationMode  ITEMIZE
InterpolationModeInvalid               EQUATE(-1)
InterpolationModeDefault               EQUATE(0)
InterpolationModeLowQuality            EQUATE(1)
InterpolationModeHighQuality           EQUATE(2)
InterpolationModeBilinear              EQUATE(3)
InterpolationModeBicubic               EQUATE(4)
InterpolationModeNearestNeighbor       EQUATE(5)
InterpolationModeHighQualityBilinear   EQUATE(6)
InterpolationModeHighQualityBicubic    EQUATE(7)
   END


Enum:WrapMode                          EQUATE(LONG) ! Various wrap modes for brushes
!--------------------------------------------------
WrapMode ITEMIZE(0)
WrapModeTile                           EQUATE ! 0
WrapModeTileFlipX                      EQUATE ! 1
WrapModeTileFlipY                      EQUATE ! 2
WrapModeTileFlipXY                     EQUATE ! 3
WrapModeClamp                          EQUATE ! 4
   END

Enum:LinearGradientMode                EQUATE(LONG)
!--------------------------------------------------
LinearGradientMode  ITEMIZE(0)
LinearGradientModeHorizontal           EQUATE  ! 0
LinearGradientModeVertical             EQUATE  ! 1
LinearGradientModeForwardDiagonal      EQUATE  ! 2
LinearGradientModeBackwardDiagonal     EQUATE  ! 3
   END

Enum:ImageType                         EQUATE(LONG)
!--------------------------------------------------
ImageType ITEMIZE(0)
ImageTypeUnknown                       EQUATE ! 0
ImageTypeBitmap                        EQUATE ! 1
ImageTypeMetafile                      EQUATE ! 2
   END


Enum:HatchStyle                        EQUATE(LONG) ! Various Hatch Styles
!-----------------------------------------------------
HatchStyle ITEMIZE(0)
HatchStyleHorizontal                   EQUATE    ! 0
HatchStyleVertical                     EQUATE    ! 1
HatchStyleForwardDiagonal              EQUATE    ! 2
HatchStyleBackwardDiagonal             EQUATE    ! 3
HatchStyleCross                        EQUATE    ! 4
HatchStyleDiagonalCross                EQUATE    ! 5
HatchStyle05Percent                    EQUATE    ! 6
HatchStyle10Percent                    EQUATE    ! 7
HatchStyle20Percent                    EQUATE    ! 8
HatchStyle25Percent                    EQUATE    ! 9
HatchStyle30Percent                    EQUATE    ! 10
HatchStyle40Percent                    EQUATE    ! 11
HatchStyle50Percent                    EQUATE    ! 12
HatchStyle60Percent                    EQUATE    ! 13
HatchStyle70Percent                    EQUATE    ! 14
HatchStyle75Percent                    EQUATE    ! 15
HatchStyle80Percent                    EQUATE    ! 16
HatchStyle90Percent                    EQUATE    ! 17
HatchStyleLightDownwardDiagonal        EQUATE    ! 18
HatchStyleLightUpwardDiagonal          EQUATE    ! 19
HatchStyleDarkDownwardDiagonal         EQUATE    ! 20
HatchStyleDarkUpwardDiagonal           EQUATE    ! 21
HatchStyleWideDownwardDiagonal         EQUATE    ! 22
HatchStyleWideUpwardDiagonal           EQUATE    ! 23
HatchStyleLightVertical                EQUATE    ! 24
HatchStyleLightHorizontal              EQUATE    ! 25
HatchStyleNarrowVertical               EQUATE    ! 26
HatchStyleNarrowHorizontal             EQUATE    ! 27
HatchStyleDarkVertical                 EQUATE    ! 28
HatchStyleDarkHorizontal               EQUATE    ! 29
HatchStyleDashedDownwardDiagonal       EQUATE    ! 30
HatchStyleDashedUpwardDiagonal         EQUATE    ! 31
HatchStyleDashedHorizontal             EQUATE    ! 32
HatchStyleDashedVertical               EQUATE    ! 33
HatchStyleSmallConfetti                EQUATE    ! 34
HatchStyleLargeConfetti                EQUATE    ! 35
HatchStyleZigZag                       EQUATE    ! 36
HatchStyleWave                         EQUATE    ! 37
HatchStyleDiagonalBrick                EQUATE    ! 38
HatchStyleHorizontalBrick              EQUATE    ! 39
HatchStyleWeave                        EQUATE    ! 40
HatchStylePlaid                        EQUATE    ! 41
HatchStyleDivot                        EQUATE    ! 42
HatchStyleDottedGrid                   EQUATE    ! 43
HatchStyleDottedDiamond                EQUATE    ! 44
HatchStyleShingle                      EQUATE    ! 45
HatchStyleTrellis                      EQUATE    ! 46
HatchStyleSphere                       EQUATE    ! 47
HatchStyleSmallGrid                    EQUATE    ! 48
HatchStyleSmallCheckerBoard            EQUATE    ! 49
HatchStyleLargeCheckerBoard            EQUATE    ! 50
HatchStyleOutlinedDiamond              EQUATE    ! 51
HatchStyleSolidDiamond                 EQUATE    ! 52
HatchStyleTotal                        EQUATE    ! 53
HatchStyleLargeGrid                    EQUATE(4) ! HatchStyleCross   4
HatchStyleMin                          EQUATE(0) ! HatchStyleHorizontal
HatchStyleMax                          EQUATE(52)! HatchStyleTotal - 1
   END

Enum:MatrixOrder           EQUATE(LONG)
!---------------------------------------
MatrixOrder ITEMIZE(0)
MatrixOrderPrepend         EQUATE ! 0
MatrixOrderAppend          EQUATE ! 1
   END


Enum:ColorAdjustType       EQUATE(LONG)
!---------------------------------------
ColorAdjustType  ITEMIZE
ColorAdjustTypeDefault     EQUATE
ColorAdjustTypeBitmap      EQUATE
ColorAdjustTypeBrush       EQUATE
ColorAdjustTypePen         EQUATE
ColorAdjustTypeText        EQUATE
ColorAdjustTypeCount       EQUATE
ColorAdjustTypeAny         EQUATE  ! Reserved
   END

Enum:ColorChannelFlags     EQUATE(LONG)
!--------------------------------------
ColorChannelFlags ITEMIZE(0)
ColorChannelFlagsC         EQUATE
ColorChannelFlagsM         EQUATE
ColorChannelFlagsY         EQUATE
ColorChannelFlagsK         EQUATE
ColorChannelFlagsLast      EQUATE
   END

Enum:ColorMatrixFlags      EQUATE(LONG)
!--------------------------------------
ColorMatrixFlags ITEMIZE(0)
ColorMatrixFlagsDefault    EQUATE
ColorMatrixFlagsSkipGrays  EQUATE
ColorMatrixFlagsAltGray    EQUATE
   END

Enum:PenAlignment          EQUATE(LONG)
!--------------------------------------
PenAlignment  ITEMIZE(0)
PenAlignmentCenter         EQUATE ! 0
PenAlignmentInset          EQUATE ! 1
   END

Enum:BrushType             EQUATE(LONG)
!--------------------------------------
BrushType ITEMIZE(0)
BrushTypeSolidColor        EQUATE ! 0
BrushTypeHatchFill         EQUATE ! 1
BrushTypeTextureFill       EQUATE ! 2
BrushTypePathGradient      EQUATE ! 3
BrushTypeLinearGradient    EQUATE ! 4
   END

Enum:DashStyle             EQUATE(LONG)
!--------------------------------------
DashStyle ITEMIZE(0)
DashStyleSolid             EQUATE  ! 0
DashStyleDash              EQUATE  ! 1
DashStyleDot               EQUATE  ! 2
DashStyleDashDot           EQUATE  ! 3
DashStyleDashDotDot        EQUATE  ! 4
DashStyleCustom            EQUATE  ! 5
   END

Enum:DashCap               EQUATE(LONG)  ! Dash cap constants
!--------------------------------------
DashCap ITEMIZE
DashCapFlat                EQUATE(0)
DashCapRound               EQUATE(2)
DashCapTriangle            EQUATE(3)
   END

Enum:LineCap               EQUATE(LONG)  ! Line cap constants (only the lowest 8 bits are used).
!-------------------------------------
LineCap  ITEMIZE(0)
LineCapFlat                EQUATE
LineCapSquare              EQUATE
LineCapRound               EQUATE
LineCapTriangle            EQUATE
LineCapNoAnchor            EQUATE(010h)       ! corresponds to flat cap
LineCapSquareAnchor        EQUATE(011h)       ! corresponds to square cap
LineCapRoundAnchor         EQUATE(012h)       ! corresponds to round cap
LineCapDiamondAnchor       EQUATE(013h)       ! corresponds to triangle cap
LineCapArrowAnchor         EQUATE(014h)       ! no correspondence
LineCapCustom              EQUATE(0FFh)       ! custom cap
LineCapAnchorMask          EQUATE(0F0h)       ! mask to check for anchor or not.
   END


Enum:CustomLineCapType           EQUATE(LONG) ! Custom Line cap type constants
!---------------------------------------
CustomLineCapType ITEMIZE(0)
CustomLineCapTypeDefault         EQUATE
CustomLineCapTypeAdjustableArrow EQUATE
   END


Enum:LineJoin         EQUATE(LONG)           ! Line join constants
!--------------------------------------
LineJoin ITEMIZE(0)
LineJoinMiter         EQUATE
LineJoinBevel         EQUATE
LineJoinRound         EQUATE
LineJoinMiterClipped  EQUATE
   END

Enum:PenType          EQUATE(LONG)           ! Pen's Fill types
!-------------------------------------
PenType ITEMIZE
PenTypeSolidColor     EQUATE(BrushTypeSolidColor)
PenTypeHatchFill      EQUATE(BrushTypeHatchFill)
PenTypeTextureFill    EQUATE(BrushTypeTextureFill)
PenTypePathGradient   EQUATE(BrushTypePathGradient)
PenTypeLinearGradient EQUATE(BrushTypeLinearGradient)
PenTypeUnknown        EQUATE(-1)
   END

Enum:WarpMode         EQUATE(LONG)
!----------------------------------
WarpMode ITEMIZE(0)
WarpModePerspective   EQUATE   ! 0
WarpModeBilinear      EQUATE   ! 1
   END

Enum:CombineMode       EQUATE(LONG) ! Region Combine Modes
!----------------------------------
CombineMode  ITEMIZE(0)
CombineModeReplace     EQUATE  ! 0
CombineModeIntersect   EQUATE  ! 1
CombineModeUnion       EQUATE  ! 2
CombineModeXor         EQUATE  ! 3
CombineModeExclude     EQUATE  ! 4
CombineModeComplement  EQUATE  ! 5 (Exclude From)
   END


Enum:RotateFlipType    EQUATE(LONG)
!------------------------------------------
RotateFlipType ITEMIZE
RotateNoneFlipNone     EQUATE(0)
Rotate90FlipNone       EQUATE(1)
Rotate180FlipNone      EQUATE(2)
Rotate270FlipNone      EQUATE(3)

RotateNoneFlipX        EQUATE(4)
Rotate90FlipX          EQUATE(5)
Rotate180FlipX         EQUATE(6)
Rotate270FlipX         EQUATE(7)

RotateNoneFlipY        EQUATE(Rotate180FlipX)
Rotate90FlipY          EQUATE(Rotate270FlipX)
Rotate180FlipY         EQUATE(RotateNoneFlipX)
Rotate270FlipY         EQUATE(Rotate90FlipX)

RotateNoneFlipXY       EQUATE(Rotate180FlipNone)
Rotate90FlipXY         EQUATE(Rotate270FlipNone)
Rotate180FlipXY        EQUATE(RotateNoneFlipNone)
Rotate270FlipXY        EQUATE(Rotate90FlipNone)
   END


!  String format flags
!  ===================
!
!  DirectionRightToLeft          - For horizontal text, the reading order is  right to left. This value is called
!                                  the base embedding level by the Unicode  bidirectional engine.
!                                  For vertical text, columns are read from right to left.
!                                  By default, horizontal or vertical text is read from left to right.
!
!  DirectionVertical             - Individual lines of text are vertical. In each line, characters progress from top to bottom.
!                                  By default, lines of text are horizontal, each new line below the previous line.
!
!  NoFitBlackBox                 - Allows parts of glyphs to overhang the bounding rectangle.
!                                  By default glyphs are first aligned inside the margines, then any glyphs which
!                                  still overhang the bounding box are repositioned to avoid any overhang.
!                                  For example when an italic lower case letter f in a font such as
!                                  Garamond is aligned at the far left of a rectangle, the lower part of the f will
!                                  reach slightly further left than the left edge of the rectangle. Setting this flag
!                                  will ensure the character aligns visually with the lines above and below, but may
!                                  cause some pixels outside the formatting rectangle to be clipped or painted.
!
!  DisplayFormatControl          - Causes control characters such as the left-to-right mark to be shown in the
!                                  output with a representative glyph.
!
!  NoFontFallback                - Disables fallback to alternate fonts for characters not supported in the requested
!                                  font. Any missing characters will be be displayed with the fonts missing glyph,
!                                  usually an open square.
!
!  NoWrap                        - Disables wrapping of text between lines when formatting within a rectangle.
!                                  NoWrap is implied when a point is passed instead of a rectangle, or when the
!                                  specified rectangle has a zero line length.
!
!  NoClip                        - By default text is clipped to the formatting rectangle. Setting NoClip
!                                  allows overhanging pixels to affect the device outside the formatting rectangle.
!                                  Pixels at the end of the line may be affected if the glyphs overhang their
!                                  cells, and either the NoFitBlackBox flag has been set, or the glyph extends to far
!                                  to be fitted.
!                                  Pixels above/before the first line or below/after the last line may be affected
!                                  if the glyphs extend beyond their cell ascent / descent. This can occur rarely
!                                  with unusual diacritic mark combinations.

Enum:StringFormatFlags                  EQUATE(LONG)
!-----------------------------------------------------
StringFormatFlags ITEMIZE
StringFormatFlagsDirectionRightToLeft   EQUATE(01h)
StringFormatFlagsDirectionVertical      EQUATE(02h)
StringFormatFlagsNoFitBlackBox          EQUATE(04h)
StringFormatFlagsDisplayFormatControl   EQUATE(020h)
StringFormatFlagsNoFontFallback         EQUATE(0400h)
StringFormatFlagsMeasureTrailingSpaces  EQUATE(0800h)
StringFormatFlagsNoWrap                 EQUATE(01000h)
StringFormatFlagsLineLimit              EQUATE(02000h)
StringFormatFlagsNoClip                 EQUATE(04000h)
   END


Enum:StringTrimming                     EQUATE(LONG)
!-----------------------------------------------------
StringTrimming ITEMIZE(0)
StringTrimmingNone                      EQUATE
StringTrimmingCharacter                 EQUATE
StringTrimmingWord                      EQUATE
StringTrimmingEllipsisCharacter         EQUATE
StringTrimmingEllipsisWord              EQUATE
StringTrimmingEllipsisPath              EQUATE
   END


Enum:StringDigitSubstitute             EQUATE(LONG)    ! National language digit substitution
!-----------------------------------------------------
StringDigitSubstitute  ITEMIZE(0)
StringDigitSubstituteUser               EQUATE         ! As NLS setting
StringDigitSubstituteNone               EQUATE
StringDigitSubstituteNational           EQUATE
StringDigitSubstituteTraditional        EQUATE
   END


Enum:HotkeyPrefix                       EQUATE(LONG)  ! Hotkey prefix interpretation
!-----------------------------------------------------
HotkeyPrefix ITEMIZE(0)
HotkeyPrefixNone                        EQUATE
HotkeyPrefixShow                        EQUATE
HotkeyPrefixHide                        EQUATE
   END

! Left edge for left-to-right text,  right for right-to-left text, and top for vertical

Enum:StringAlignment                    EQUATE(LONG)
!-----------------------------------------------------
StringAlignment  ITEMIZE(0)
StringAlignmentNear                     EQUATE
StringAlignmentCenter                   EQUATE
StringAlignmentFar                      EQUATE
   END

Enum:FlushIntention                     EQUATE(LONG)
!-----------------------------------------------------
FlushIntention ITEMIZE(0)
FlushIntentionFlush                     EQUATE          ! Flush all batched rendering operations
FlushIntentionSync                      EQUATE          ! and wait for them to complete
   END


Enum:EncoderParameterValueType          EQUATE(LONG)    ! Image encoder parameter related types
!------------------------------------------------------
EncoderParameterValueType  ITEMIZE
EncoderParameterValueTypeByte           EQUATE(1)     ! 8-bit unsigned int
EncoderParameterValueTypeASCII          EQUATE(2)     ! 8-bit byte containing one 7-bit ASCII code. NULL terminated.
EncoderParameterValueTypeShort          EQUATE(3)     ! 16-bit unsigned int
EncoderParameterValueTypeLong           EQUATE(4)     ! 32-bit unsigned int
EncoderParameterValueTypeRational       EQUATE(5)     ! Two Longs. The first Long is the numerator the second Long expresses the denomintor.
EncoderParameterValueTypeLongRange      EQUATE(6)     ! Two longs which specify a range of integer values. The first Long specifies
                                                      ! the lower end and the second one specifies the higher end. All values
                                                      ! are inclusive at both ends.
EncoderParameterValueTypeUndefined      EQUATE(7)     ! 8-bit byte that can take any value depending on field definition
EncoderParameterValueTypeRationalRange  EQUATE(8)     ! Two Rationals. The first Rational specifies the lower end and the second
  END                                                 ! specifies the higher end. All values are inclusive at both ends
   


Enum:EncoderValue                       EQUATE(LONG) ! Image encoder value types
!----------------------------------------------------
EncoderValue ITEMIZE
EncoderValueColorTypeCMYK               EQUATE
EncoderValueColorTypeYCCK               EQUATE
EncoderValueCompressionLZW              EQUATE
EncoderValueCompressionCCITT3           EQUATE
EncoderValueCompressionCCITT4           EQUATE
EncoderValueCompressionRle              EQUATE
EncoderValueCompressionNone             EQUATE
EncoderValueScanMethodInterlaced        EQUATE
EncoderValueScanMethodNonInterlaced     EQUATE
EncoderValueVersionGif87                EQUATE
EncoderValueVersionGif89                EQUATE
EncoderValueRenderProgressive           EQUATE
EncoderValueRenderNonProgressive        EQUATE
EncoderValueTransformRotate90           EQUATE
EncoderValueTransformRotate180          EQUATE
EncoderValueTransformRotate270          EQUATE
EncoderValueTransformFlipHorizontal     EQUATE
EncoderValueTransformFlipVertical       EQUATE
EncoderValueMultiFrame                  EQUATE
EncoderValueLastFrame                   EQUATE
EncoderValueFlush                       EQUATE
EncoderValueFrameDimensionTime          EQUATE
EncoderValueFrameDimensionResolution    EQUATE
EncoderValueFrameDimensionPage          EQUATE
   END


! CLSIDs (aka GUIDs) used with the EncoderParameter structure:
! NOTE: You won!t find this enum in the GDI+ Docs. It was created as part of the workaround for the constant GUID problem.
!-------------------------------------------------------------------------------------------------------------------------
Enum:EncoderParameterGUIDs              EQUATE(LONG)
!--------------------------------------------------
EncoderParameterGUIDs  ITEMIZE
EncoderCompression                      EQUATE
EncoderColorDepth                       EQUATE
EncoderScanMethod                       EQUATE
EncoderVersion                          EQUATE
EncoderRenderMethod                     EQUATE
EncoderQuality                          EQUATE
EncoderTransformation                   EQUATE
EncoderLuminanceTable                   EQUATE
EncoderChrominanceTable                 EQUATE
EncoderSaveFlag                         EQUATE
   END

Enum:PixelOffsetMode                    EQUATE(LONG)
!----------------------------------------------------
PixelOffsetMode  ITEMIZE
PixelOffsetModeInvalid                  EQUATE(QualityModeInvalid)
PixelOffsetModeDefault                  EQUATE(QualityModeDefault)
PixelOffsetModeHighSpeed                EQUATE(QualityModeLow)
PixelOffsetModeHighQuality              EQUATE(QualityModeHigh)
PixelOffsetModeNone                     EQUATE                   ! No pixel offset
PixelOffsetModeHalf                     EQUATE                   ! Offset by -0.5 -0.5 for fast anti-alias perf
   END

Enum:TextRenderingHint                  EQUATE(LONG)
!---------------------------------------------------
TextRenderingHint  ITEMIZE(0)
TextRenderingHintSystemDefault             EQUATE   ! Glyph with system default rendering hint
TextRenderingHintSingleBitPerPixelGridFit  EQUATE   ! Glyph bitmap with hinting
TextRenderingHintSingleBitPerPixel         EQUATE   ! Glyph bitmap without hinting
TextRenderingHintAntiAliasGridFit          EQUATE   ! Glyph anti-alias bitmap with hinting
TextRenderingHintAntiAlias                 EQUATE   ! Glyph anti-alias bitmap without hinting
TextRenderingHintClearTypeGridFit          EQUATE   ! Glyph CT bitmap with hinting
   END

Enum:MetafileType                       EQUATE(LONG)
!---------------------------------------------------
MetafileType  ITEMIZE
MetafileTypeInvalid                     EQUATE    ! Invalid metafile
MetafileTypeWmf                         EQUATE    ! Standard WMF
MetafileTypeWmfPlaceable                EQUATE    ! Placeable WMF
MetafileTypeEmf                         EQUATE    ! EMF (not EMF+)
MetafileTypeEmfPlusOnly                 EQUATE    ! EMF+ without dual down-level records
MetafileTypeEmfPlusDual                 EQUATE    ! EMF+ with dual down-level records
   END


Enum:MetafileType                       EQUATE(LONG) ! Specifies the type of EMF to record
!---------------------------------------------------
EmfType  ITEMIZE
EmfTypeEmfOnly                          EQUATE(MetafileTypeEmf)           ! no EMF+  only EMF
EmfTypeEmfPlusOnly                      EQUATE(MetafileTypeEmfPlusOnly)   ! no EMF  only EMF+
EmfTypeEmfPlusDual                      EQUATE(MetafileTypeEmfPlusDual)   ! both EMF+ and EMF
   END


Enum:ObjectType                         EQUATE(LONG)             ! EMF+ Persistent object types
!---------------------------------------------------
ObjectType  ITEMIZE
ObjectTypeInvalid                       EQUATE
ObjectTypeBrush                         EQUATE
ObjectTypePen                           EQUATE
ObjectTypePath                          EQUATE
ObjectTypeRegion                        EQUATE
ObjectTypeImage                         EQUATE
ObjectTypeFont                          EQUATE
ObjectTypeStringFormat                  EQUATE
ObjectTypeImageAttributes               EQUATE
ObjectTypeCustomLineCap                 EQUATE
ObjectTypeMax                           EQUATE(ObjectTypeCustomLineCap)
ObjectTypeMin                           EQUATE(ObjectTypeBrush)
   END

! The frameRect for creating a metafile can be specified in any of these
! units.  There is an extra frame unit value (MetafileFrameUnitGdi) so
! that units can be supplied in the same units that GDI expects for
! frame rects -- these units are in .01 (1/100ths) millimeter units
! as defined by GDI.
!
Enum:MetafileFrameUnit                  EQUATE(LONG)
!---------------------------------------------------------------------
MetafileFrameUnit  ITEMIZE
MetafileFrameUnitPixel                    EQUATE(gpUnitPixel)
MetafileFrameUnitPoint                    EQUATE(gpUnitPoint)
MetafileFrameUnitInch                     EQUATE(gpUnitInch)
MetafileFrameUnitDocument                 EQUATE(gpUnitDocument)
MetafileFrameUnitMillimeter               EQUATE(gpUnitMillimeter)
MetafileFrameUnitGdi                      EQUATE             ! GDI compatible .01 MM units
   END


Enum:CoordinateSpace                      EQUATE(LONG) ! Coordinate space identifiers
!--------------------------------------------
CoordinateSpace  ITEMIZE(0)
CoordinateSpaceWorld                      EQUATE  ! 0
CoordinateSpacePage                       EQUATE  ! 1
CoordinateSpaceDevice                     EQUATE  ! 2
   END


!-----------------------------------------------
! GDI+ Structs/Types
!-----------------------------------------------

POINTL GROUP,TYPE     
x      LONG
y      LONG
 END

POINTF  GROUP,TYPE    
x      SREAL
y      SREAL
 END

RECTL  GROUP,TYPE     
Left   LONG
Top    LONG
Right  LONG
Bottom LONG
 END

RECTF  GROUP,TYPE     
Left   SREAL
Top    SREAL
Right  SREAL
Bottom SREAL
 END

SIZEL  GROUP,TYPE     
cx     LONG
cy     LONG
 END

SIZEF  GROUP,TYPE     
cx     SREAL
cy     SREAL
 END

COLORBYTES  GROUP,TYPE  ! Custom types
BlueByte    LONG
GreenByte   LONG
RedByte     LONG
AlphaByte   LONG
 END

COLORLONG  GROUP,TYPE
longval     LONG
 END

GdiplusStartupInput GROUP,TYPE
GdiplusVersion             LONG      ! Must be 1
DebugEventCallback         LONG      ! Ignored on free builds
SuppressBackgroundThread   LONG      ! FALSE unless you!re prepared to call the hook/unhook functions properly
SuppressExternalCodecs     LONG      ! FALSE unless you want GDI+ only to use its internal image codecs.
 END

!-----------------------------------------------
!  GDI+ API Functions
!-----------------------------------------------

  MAP
    MODULE('Gdiplus.dll')

!-----------------------------------------------
! Init GDI+ Functions
!-----------------------------------------------

GdiplusStartup               PROCEDURE(LONG Token, LONG GdiPlusStartupInput, LONG OutputBuf=0),PASCAL,RAW,LONG            !  GDI+
GdiplusShutdown              PROCEDURE(LONG Token),PASCAL,RAW,LONG                       !   GDI+

! GDI+ Functions (No Streaming)
!-----------------------------------------------
GdipFlush                    PROCEDURE(LONG ptrGraphics, Enum:FlushIntention FlushIntention),PASCAL,RAW,LONG
GdipCreateFromHDC            PROCEDURE(HDC ptrHDC, LONG ptrGraphics),PASCAL,RAW,LONG     !   GDI+  HDC 
GdipCreateFromHWND           PROCEDURE(LONG hwnd, LONG ptrGraphics),PASCAL,RAW,LONG
GdipDeleteGraphics           PROCEDURE(LONG ptrGraphics),PASCAL,RAW,LONG                 !   GDI+
GdipGraphicsClear            PROCEDURE(LONG ptrGraphics, LONG BkColor),PASCAL,RAW,LONG   !     


GdipGetDC                    PROCEDURE(LONG ptrGraphics, LONG Hdc),PASCAL,RAW,LONG
GdipReleaseDC                PROCEDURE(LONG ptrGraphics, LONG ptrHdc),PASCAL,RAW,LONG

GdipSetCompositingMode       PROCEDURE(LONG ptrGraphics, Enum:CompositingMode CompositingMode),PASCAL,RAW,LONG
GdipGetCompositingMode       PROCEDURE(LONG ptrGraphics, LONG ptrCompositingMode),PASCAL,RAW,LONG

GdipSetRenderingOrigin       PROCEDURE(LONG ptrGraphics, LONG x, LONG y),PASCAL,RAW,LONG
GdipGetRenderingOrigin       PROCEDURE(LONG ptrGraphics, LONG x, LONG y),PASCAL,RAW,LONG

GdipSetCompositingQuality    PROCEDURE(LONG ptrGraphics, LONG CompositingQuality),PASCAL,LONG,RAW
GdipGetCompositingQuality    PROCEDURE(LONG ptrGraphics, LONG ptrCompositingQuality),PASCAL,RAW,LONG

GdipSetSmoothingMode         PROCEDURE(LONG ptrGraphics, LONG SmoothingMode),PASCAL,LONG,RAW
GdipGetSmoothingMode         PROCEDURE(LONG ptrGraphics, LONG ptrSmoothingMode),PASCAL,RAW,LONG

GdipSetPixelOffsetMode       PROCEDURE(LONG ptrGraphics, LONG PixelOffsetMode),PASCAL,RAW,LONG
GdipGetPixelOffsetMode       PROCEDURE(LONG ptrGraphics, LONG ptrPixelOffsetMode),PASCAL,RAW,LONG

GdipSetTextRenderingHint     PROCEDURE(LONG ptrGraphics, LONG TextRenderingHint),PASCAL,RAW,LONG
GdipGetTextRenderingHint     PROCEDURE(LONG ptrGraphics, LONG ptrTextRenderingHint),PASCAL,RAW,LONG

GdipSetTextContrast          PROCEDURE(LONG ptrGraphics, LONG Contrast),PASCAL,RAW,LONG
GdipGetTextContrast          PROCEDURE(LONG ptrGraphics, LONG ptrContrast),PASCAL,RAW,LONG

GdipSetInterpolationMode     PROCEDURE(LONG ptrGraphics, LONG InterpolationMode),PASCAL,RAW,LONG
GdipGetInterpolationMode     PROCEDURE(LONG ptrGraphics, LONG ptrInterpolationMode),PASCAL,RAW,LONG

GdipSetWorldTransform        PROCEDURE(LONG ptrGraphics, LONG matrix),PASCAL,RAW,LONG
GdipResetWorldTransform      PROCEDURE(LONG ptrGraphics),PASCAL,RAW,LONG
GdipMultiplyWorldTransform   PROCEDURE(LONG ptrGraphics, LONG matrix,LONG MatrixOrder),PASCAL,RAW,LONG
GdipTranslateWorldTransform  PROCEDURE(LONG ptrGraphics, SREAL dx, SREAL dy, LONG MatrixOrder),PASCAL,RAW,LONG
GdipScaleWorldTransform      PROCEDURE(LONG ptrGraphics, SREAL sx, SREAL sy, LONG MatrixOrder),PASCAL,RAW,LONG

GdipRotateWorldTransform     PROCEDURE(LONG ptrGraphics, SREAL RotateAngle, LONG MatrixOrder),PASCAL,LONG,RAW

GdipGetWorldTransform        PROCEDURE(LONG ptrGraphics, LONG ptrMatrix),PASCAL,RAW,LONG
GdipResetPageTransform       PROCEDURE(LONG ptrGraphics),PASCAL,RAW,LONG

GdipGetPageUnit              PROCEDURE(LONG ptrGraphics, LONG ptrUnit),PASCAL,RAW,LONG
GdipSetPageUnit              PROCEDURE(LONG ptrGraphics, LONG ptrUnit),PASCAL,RAW,LONG

GdipGetPageScale             PROCEDURE(LONG ptrGraphics, SREAL ptrSscale),PASCAL,RAW,LONG
GdipSetPageScale             PROCEDURE(LONG ptrGraphics, SREAL ptrSscale),PASCAL,RAW,LONG

GdipGetDpiX                  PROCEDURE(LONG ptrGraphics, SREAL dpi),PASCAL,RAW,LONG
GdipGetDpiY                  PROCEDURE(LONG ptrGraphics, SREAL dpi),PASCAL,RAW,LONG

GdipTransformPoints          PROCEDURE(LONG ptrGraphics,  LONG destCoordinateSpace,  LONG srcCoordinateSpace, LONG ptrPointsF, LONG countPoint),PASCAL,RAW,LONG
GdipTransformPointsI         PROCEDURE(LONG ptrGraphics,  LONG destCoordinateSpace,  LONG srcCoordinateSpace, LONG ptrPointsL, LONG countPoint),PASCAL,RAW,LONG

GdipGetNearestColor          PROCEDURE(LONG ptrGraphics, LONG argb),PASCAL,RAW,LONG
GdipCreateHalftonePalette    PROCEDURE(),PASCAL,RAW,LONG    !Creates the Win9x Halftone Palette PROCEDURE(even on NT) with correct Desktop colors

GdipDrawLine                 PROCEDURE(LONG ptrGraphics, LONG ptrPen, SREAL x1, SREAL y1, SREAL x2,  SREAL y2),PASCAL,RAW,LONG
GdipDrawLineI                PROCEDURE(LONG ptrGraphics, LONG ptrPen, LONG X1,  LONG Y1,  LONG X2, LONG Y2),PASCAL,LONG,RAW    !  
GdipDrawLines                PROCEDURE(LONG ptrGraphics, LONG ptrPen, LONG ptrPointF,  LONG countPoint),PASCAL,RAW,LONG
GdipDrawLinesI               PROCEDURE(LONG ptrGraphics, LONG ptrPen, LONG ptrPointL,  LONG countPoint),PASCAL,RAW,LONG

GdipDrawArc                  PROCEDURE(LONG ptrGraphics, LONG ptrPen,  SREAL x,  SREAL y,  SREAL rWidth,  SREAL rHeight,  SREAL StartAngle,  SREAL SweepAngle),PASCAL,RAW,LONG
GdipDrawArcI                 PROCEDURE(LONG ptrGraphics, LONG ptrPen,  LONG x,  LONG y,  LONG rWidth,  LONG rHeight,  SREAL StartAngle,  SREAL SweepAngle),PASCAL,RAW,LONG

GdipDrawBezier               PROCEDURE(LONG ptrGraphics, LONG ptrPen,  SREAL x1,  SREAL y1,  SREAL x2,  SREAL y2,  x3  SREAL,  y3  SREAL,  x4  SREAL,  y4  SREAL),PASCAL,RAW,LONG
GdipDrawBezierI              PROCEDURE(LONG ptrGraphics, LONG ptrPen,  x1  Long,  y1  Long,  x2  Long,  y2  Long,  x3  Long,  y3  Long,  x4  Long,  y4  Long),PASCAL,RAW,LONG
GdipDrawBeziers              PROCEDURE(LONG ptrGraphics, LONG ptrPen, LONG ptrPointF,  LONG countPoint),PASCAL,RAW,LONG

GdipDrawBeziersI             PROCEDURE(LONG ptrGraphics, LONG ptrPen, LONG ptrPointL,  LONG countPoint),PASCAL,RAW,LONG
GdipDrawRectangle            PROCEDURE(LONG ptrGraphics, LONG ptrPen, SREAL x,  SREAL y,  SREAL rWidth,  SREAL rHeight),PASCAL,RAW,LONG
GdipDrawRectangleI           PROCEDURE(LONG ptrGraphics, LONG ptrPen, LONG x, LONG y, LONG rWidth, LONG rHeight),PASCAL,RAW,LONG
GdipDrawRectangles           PROCEDURE(LONG ptrGraphics, LONG ptrPen, LONG ptrRects,  LONG count),PASCAL,RAW,LONG
GdipDrawRectanglesI          PROCEDURE(LONG ptrGraphics, LONG ptrPen, LONG ptrRectsL, LONG countPoint),PASCAL,RAW,LONG

GdipDrawEllipse              PROCEDURE(LONG ptrGraphics, LONG ptrPen,  SREAL x, SREAL y, SREAL rWidth, SREAL rHeight),PASCAL,RAW,LONG
GdipDrawEllipseI             PROCEDURE(LONG ptrGraphics, LONG ptrPen,  LONG  x, LONG  y, LONG  rWidth, LONG  rHeight),PASCAL,RAW,LONG

GdipDrawPie                  PROCEDURE(LONG ptrGraphics, LONG ptrPen,  SREAL x, SREAL y,  SREAL rWidth,  SREAL rHeight,  SREAL StartAngle,  SREAL SweepAngle),PASCAL,RAW,LONG
GdipDrawPieI                 PROCEDURE(LONG ptrGraphics, LONG ptrPen,  LONG x,  LONG y,  LONG rWidth,  LONG rHeight,  SREAL StartAngle,  SREAL SweepAngle),PASCAL,RAW,LONG

GdipDrawPolygon              PROCEDURE(LONG ptrGraphics, LONG ptrPen, LONG ptrPointF,  LONG countPoint),PASCAL,RAW,LONG
GdipDrawPolygonI             PROCEDURE(LONG ptrGraphics, LONG ptrPen, LONG ptrPointL,  LONG countPoint),PASCAL,RAW,LONG

GdipDrawPath                 PROCEDURE(LONG ptrGraphics, LONG ptrBrush,  LONG ptrPath),PASCAL,RAW,LONG

GdipDrawCurve                PROCEDURE(LONG ptrGraphics, LONG ptrPen, LONG ptrPointF,  LONG countPoint),PASCAL,RAW,LONG
GdipDrawCurveI               PROCEDURE(LONG ptrGraphics, LONG ptrPen, LONG ptrArrPointCurve, LONG SizeArrPointCurve),PASCAL,LONG,RAW
GdipDrawCurve2               PROCEDURE(LONG ptrGraphics, LONG ptrPen, LONG ptrPointF,  LONG countPoint,  SREAL Tension),PASCAL,RAW,LONG
GdipDrawCurve2I              PROCEDURE(LONG ptrGraphics, LONG ptrPen, LONG ptrPointL,  LONG countPoint,  SREAL Tension),PASCAL,RAW,LONG
GdipDrawCurve3               PROCEDURE(LONG ptrGraphics, LONG ptrPen, LONG ptrPointF,  LONG countPoint,  offset  Long,  numberOfSegments  Long,  SREAL Tension),PASCAL,RAW,LONG
GdipDrawCurve3I              PROCEDURE(LONG ptrGraphics, LONG ptrPen, LONG ptrPointL,  LONG countPoint,  offset  Long,  numberOfSegments  Long,  SREAL Tension),PASCAL,RAW,LONG
GdipDrawClosedCurve          PROCEDURE(LONG ptrGraphics, LONG ptrPen, LONG ptrPointF,  LONG countPoint),PASCAL,RAW,LONG
GdipDrawClosedCurveI         PROCEDURE(LONG ptrGraphics, LONG ptrPen, LONG ptrPointL,  LONG countPoint),PASCAL,RAW,LONG
GdipDrawClosedCurve2         PROCEDURE(LONG ptrGraphics, LONG ptrPen, LONG ptrPointF,  LONG countPoint,  SREAL Tension),PASCAL,RAW,LONG
GdipDrawClosedCurve2I        PROCEDURE(LONG ptrGraphics, LONG ptrPen, LONG ptrPointL,  LONG countPoint,  SREAL Tension),PASCAL,RAW,LONG

GdipFillRectangle            PROCEDURE(LONG ptrGraphics, LONG ptrBrush, SREAL x, SREAL y, SREAL rWidth,  SREAL rHeight),PASCAL,RAW,LONG
GdipFillRectangleI           PROCEDURE(LONG ptrGraphics, LONG ptrBrush, LONG  x, LONG y,  LONG rWidth,   LONG rHeight),PASCAL,RAW,LONG
GdipFillRectangles           PROCEDURE(LONG ptrGraphics, LONG ptrBrush, LONG ptrRectF, LONG countPoint),PASCAL,RAW,LONG
GdipFillRectanglesI          PROCEDURE(LONG ptrGraphics, LONG ptrBrush, LONG ArrRects, LONG CountRect),PASCAL,RAW,LONG

GdipFillPolygon              PROCEDURE(LONG ptrGraphics,  LONG ptrBrush, LONG ptrPointF, LONG countPoint, Enum:FillMode FillMd),PASCAL,RAW,LONG
GdipFillPolygonI             PROCEDURE(LONG ptrGraphics,  LONG ptrBrush, LONG ptrPointL, LONG countPoint, Enum:FillMode FillMd),PASCAL,RAW,LONG
GdipFillPolygon2             PROCEDURE(LONG ptrGraphics,  LONG ptrBrush, LONG ptrPointF, LONG countPoint),PASCAL,RAW,LONG
GdipFillPolygon2I            PROCEDURE(LONG ptrGraphics,  LONG ptrBrush, LONG ptrPointL, LONG countPoint),PASCAL,RAW,LONG

GdipFillEllipse              PROCEDURE(LONG ptrGraphics,  LONG ptrBrush,  SREAL x,  SREAL y,  SREAL rWidth,  SREAL rHeight),PASCAL,RAW,LONG
GdipFillEllipseI             PROCEDURE(LONG ptrGraphics,  LONG ptrBrush,  LONG x,  LONG y,  LONG rWidth,  LONG rHeight),PASCAL,RAW,LONG

GdipFillPie                  PROCEDURE(LONG ptrGraphics,  LONG ptrBrush,  SREAL x,  SREAL y,  SREAL rWidth,  SREAL rHeight,  SREAL StartAngle,  SREAL SweepAngle),PASCAL,RAW,LONG
GdipFillPieI                 PROCEDURE(LONG ptrGraphics,  LONG ptrBrush,  LONG x,  LONG y,  LONG rWidth,  LONG rHeight,  SREAL StartAngle,  SREAL SweepAngle),PASCAL,RAW,LONG
GdipFillPath                 PROCEDURE(LONG ptrGraphics,  LONG ptrBrush,  LONG ptrPath),PASCAL,RAW,LONG

GdipFillClosedCurve          PROCEDURE(LONG ptrGraphics,  LONG ptrBrush, LONG ptrPointF,  LONG countPoint),PASCAL,RAW,LONG
GdipFillClosedCurveI         PROCEDURE(LONG ptrGraphics,  LONG ptrBrush, LONG ptrPointL,  LONG countPoint),PASCAL,RAW,LONG
GdipFillClosedCurve2         PROCEDURE(LONG ptrGraphics,  LONG ptrBrush, LONG ptrPointF,  LONG countPoint,  SREAL Tension, Enum:FillMode FillMd),PASCAL,RAW,LONG
GdipFillClosedCurve2I        PROCEDURE(LONG ptrGraphics,  LONG ptrBrush, LONG ptrPointL,  LONG countPoint,  SREAL Tension, Enum:FillMode FillMd),PASCAL,RAW,LONG

GdipFillRegion               PROCEDURE(LONG ptrGraphics,  LONG ptrBrush, LONG ptrRegion),PASCAL,RAW,LONG

GdipDrawImage                PROCEDURE(LONG ptrGraphics, LONG ptrImage , SREAL x, SREAL y),PASCAL,RAW,LONG
GdipDrawImageI               PROCEDURE(LONG ptrGraphics, LONG ptrImage,  LONG  x, LONG  y),PASCAL,RAW,LONG
GdipDrawImageRect            PROCEDURE(LONG ptrGraphics, LONG ptrImage,  SREAL xTop, SREAL yTop, SREAL ImgWidth, SREAL ImgHeight),PASCAL,LONG,RAW
                       
GdipDrawImageRectI           PROCEDURE(LONG ptrGraphics, LONG ptrImage,  LONG x, LONG y, LONG imgWidth, LONG imgHeight),PASCAL,RAW,LONG
GdipDrawImagePoints          PROCEDURE(LONG ptrGraphics, LONG ptrImage,  LONG ptrdstpoints, LONG pointscount),PASCAL,RAW,LONG
GdipDrawImagePointsI         PROCEDURE(LONG ptrGraphics, LONG ptrImage,  LONG ptrdstpoints, LONG pointscount),PASCAL,RAW,LONG
GdipDrawImagePointRect       PROCEDURE(LONG ptrGraphics, LONG ptrImage,  SREAL x, SREAL y, SREAL srcx, SREAL srcy, SREAL srcwidth, SREAL srcheight, LONG srcUnit),PASCAL,RAW,LONG
GdipDrawImagePointRectI      PROCEDURE(LONG ptrGraphics, LONG ptrImage,  LONG x, LONG y, LONG srcx, LONG srcy, LONG srcwidth, LONG dstheight, LONG srcUnit),PASCAL,RAW,LONG
GdipDrawImageRectRect        PROCEDURE(LONG ptrGraphics, LONG ptrImage,  SREAL dstx, SREAL dsty, LONG dstwidth, SREAL dstheight, SREAL srcx, SREAL srcy, SREAL srcwidth, SREAL srcheight,LONG srcUnit, LONG imageAttributes = 0, LONG callback = 0, LONG callbackData = 0),PASCAL,RAW,LONG

!  Callback declaration: DrawImageAbort(LONG lpData),LONG

GdipDrawImageRectRectI       PROCEDURE(LONG ptrGraphics, LONG ptrImage, LONG dstx, LONG dsty, LONG dstwidth, LONG dstheight, LONG srcx, LONG srcy, LONG srcwidth, LONG srcheight, LONG srcUnit, LONG imageAttributes = 0, LONG callback = 0, LONG callbackData = 0),PASCAL,RAW,LONG
GdipDrawImagePointsRect      PROCEDURE(LONG ptrGraphics, LONG ptrImage, LONG ptrPointF, LONG countPoint,  SREAL srcx, SREAL srcy,  SREAL srcwidth,  SREAL srcheight, Enum:GpUnit srcUnit, LONG imageAttributes = 0, LONG callback = 0, LONG callbackData = 0),PASCAL,RAW,LONG
GdipDrawImagePointsRectI     PROCEDURE(LONG ptrGraphics, LONG ptrImage, LONG ptrPointF, LONG countPoint,  LONG  srcx, LONG  srcy,  LONG  srcwidth,  LONG  srcheight, Enum:GpUnit srcUnit, LONG imageAttributes = 0, LONG callback = 0, LONG callbackData = 0),PASCAL,RAW,LONG

!  GdipEnumerateMetafileDestPoint          PROCEDURE(LONG ptrGraphics,  metafile  Long, destPoint  POINTF, lpEnumerateMetafileProc  Long,  callbackData  Long, imageAttributes  Long),PASCAL,RAW,LONG

!  Callback declaration: Public Function EnumMetafilesProc( rtype as EmfPlusRecordType,  _ as Long,  _ as Long, bytes as Any,  callbackData as long) as long

!  GdipEnumerateMetafileDestPointI         PROCEDURE(graphics  Long,  metafile  Long, destPoint  POINTL,  lpEnumerateMetafileProc  Long,  callbackData  Long,  imageAttributes  Long),PASCAL,RAW,LONG
!  GdipEnumerateMetafileDestRect           PROCEDURE(LONG ptrGraphics,  metafile  Long, destRect  RECTF, lpEnumerateMetafileProc  Long,  callbackData  Long, imageAttributes  Long),PASCAL,RAW,LONG
!  GdipEnumerateMetafileDestRectI          PROCEDURE(LONG ptrGraphics,  metafile  Long, destRect  RECTL, lpEnumerateMetafileProc  Long,  callbackData  Long, imageAttributes  Long),PASCAL,RAW,LONG
!  GdipEnumerateMetafileDestPoints         PROCEDURE(LONG ptrGraphics,  metafile  Long, destPoint  POINTF,  LONG countPoint, lpEnumerateMetafileProc  Long,  callbackData  Long, imageAttributes  Long),PASCAL,RAW,LONG
!  GdipEnumerateMetafileDestPointsI        PROCEDURE(LONG ptrGraphics,  metafile  Long, destPoint  POINTL,  LONG countPoint, lpEnumerateMetafileProc  Long,  callbackData  Long, imageAttributes  Long),PASCAL,RAW,LONG
!  GdipEnumerateMetafileSrcRectDestPoint   PROCEDURE(LONG ptrGraphics,  metafile  Long, destPoint  POINTF, srcRect  RECTF,  srcUnit  GpUnit,  lpEnumerateMetafileProc  Long,  callbackData  Long,  imageAttributes  Long),PASCAL,RAW,LONG
!  GdipEnumerateMetafileSrcRectDestPointI  PROCEDURE(LONG ptrGraphics,  metafile  Long, destPoint  POINTL, srcRect  RECTL,  srcUnit  GpUnit,  lpEnumerateMetafileProc  Long,  callbackData  Long,  imageAttributes  Long),PASCAL,RAW,LONG
!  GdipEnumerateMetafileSrcRectDestRect    PROCEDURE(LONG ptrGraphics,  metafile  Long, destRect  RECTF, srcRect  RECTF,  srcUnit  GpUnit,  lpEnumerateMetafileProc  Long,  callbackData  Long,  imageAttributes  Long),PASCAL,RAW,LONG
!  GdipEnumerateMetafileSrcRectDestRectI   PROCEDURE(LONG ptrGraphics,  metafile  Long, destRect  RECTL, srcRect  RECTL,  srcUnit  GpUnit,  lpEnumerateMetafileProc  Long,  callbackData  Long,  imageAttributes  Long),PASCAL,RAW,LONG
!  GdipEnumerateMetafileSrcRectDestPoints  PROCEDURE(LONG ptrGraphics,  metafile  Long, destPoints  POINTF,  LONG countPoint, srcRect  RECTF,  srcUnit  GpUnit,  lpEnumerateMetafileProc  Long,  callbackData  Long,  imageAttributes  Long),PASCAL,RAW,LONG
!  GdipEnumerateMetafileSrcRectDestPointsI PROCEDURE(LONG ptrGraphics,  metafile  Long, destPoints  POINTL,  LONG countPoint, srcRect  RECTL,  srcUnit  GpUnit,  lpEnumerateMetafileProc  Long,  callbackData  Long,  imageAttributes  Long),PASCAL,RAW,LONG

! TODO: Declare the EmfPlusRecordType enum and uncomment
! GdipPlayMetafileRecord PROCEDURE( metafile  Long,  recordType  EmfPlusRecordType,  flags  Long,  dataSize  Long, byteData  Any),PASCAL,RAW,LONG

GdipSetClipGraphics            PROCEDURE(LONG ptrGraphics, LONG srcgraphics, Enum:CombineMode CombineMd),PASCAL,RAW,LONG
GdipSetClipRect                PROCEDURE(LONG ptrGraphics, SREAL x,  SREAL y, SREAL rWidth,  SREAL rHeight,  Enum:CombineMode CombineMd),PASCAL,RAW,LONG
GdipSetClipRectI               PROCEDURE(LONG ptrGraphics, LONG x, LONG y, LONG rWidth, LONG rHeight, LONG pCombineMode),PASCAL,RAW,LONG
GdipSetClipPath                PROCEDURE(LONG ptrGraphics, LONG ptrPath, Enum:CombineMode CombineMd),PASCAL,RAW,LONG
GdipSetClipRegion              PROCEDURE(LONG ptrGraphics, LONG ptrRegion, Enum:CombineMode CombineMd),PASCAL,RAW,LONG
GdipSetClipHrgn                PROCEDURE(LONG ptrGraphics, LONG hRgn, Enum:CombineMode CombineMd),PASCAL,RAW,LONG
GdipResetClip                  PROCEDURE(LONG ptrGraphics),PASCAL,RAW,LONG

GdipTranslateClip              PROCEDURE(LONG ptrGraphics, SREALdx, SREAL dy),PASCAL,RAW,LONG
GdipTranslateClipI             PROCEDURE(LONG ptrGraphics, LONG dx, LONG dy),PASCAL,RAW,LONG
GdipGetClip                    PROCEDURE(LONG ptrGraphics, LONG ptrRegion),PASCAL,RAW,LONG
GdipGetClipBounds              PROCEDURE(LONG ptrGraphics, LONG ptrRectF),PASCAL,RAW,LONG
GdipGetClipBoundsI             PROCEDURE(LONG ptrGraphics, LONG RECTL),PASCAL,RAW,LONG
GdipIsClipEmpty                PROCEDURE(LONG ptrGraphics, LONG Result),PASCAL,RAW,LONG
GdipGetVisibleClipBounds       PROCEDURE(LONG ptrGraphics, LONG ptrRectF),PASCAL,RAW,LONG
GdipGetVisibleClipBoundsI      PROCEDURE(LONG ptrGraphics, LONG ptrRectL),PASCAL,RAW,LONG
GdipIsVisibleClipEmpty         PROCEDURE(LONG ptrGraphics, LONG Result),PASCAL,RAW,LONG
GdipIsVisiblePoint             PROCEDURE(LONG ptrGraphics, SREAL px, SREAL py, LONG Result),PASCAL,RAW,LONG
GdipIsVisiblePointI            PROCEDURE(LONG ptrGraphics, LONG  px, LONG  py, LONG Result),PASCAL,RAW,LONG
GdipIsVisibleRect              PROCEDURE(LONG ptrGraphics, SREAL rx, SREAL ry, SREAL rWidth, SREAL rHeight, LONG Result),PASCAL,RAW,LONG
GdipIsVisibleRectI             PROCEDURE(LONG ptrGraphics, LONG  rx, LONG  ry, LONG rWidth, LONG rHeight, *LONG Result),PASCAL,RAW,LONG

GdipBeginContainer             PROCEDURE(LONG ptrGraphics, LONG ptrDstRECTF, LONG ptrSrcRECTF, Enum:GpUnit, LONG state),PASCAL,RAW,LONG
GdipBeginContainerI            PROCEDURE(LONG ptrGraphics, LONG ptrdstRECTL, LONG ptrSrcRECTL, Enum:GpUnit, LONG state),PASCAL,RAW,LONG
GdipBeginContainer2            PROCEDURE(LONG ptrGraphics, LONG State),PASCAL,RAW,LONG
GdipEndContainer               PROCEDURE(LONG ptrGraphics, LONG State),PASCAL,RAW,LONG

!  GdipGetMetafileHeaderFromWmf   PROCEDURE( hWmf  Long, WmfPlaceableFileHdr  WmfPlaceableFileHeader, header  MetafileHeader),PASCAL,RAW,LONG
!  GdipGetMetafileHeaderFromEmf   PROCEDURE( hEmf  Long, header  MetafileHeader),PASCAL,RAW,LONG
!  GdipGetMetafileHeaderFromFile  PROCEDURE( filename  String, header  MetafileHeader),PASCAL,RAW,LONG
!  GdipGetMetafileHeaderFromMetafile PROCEDURE( metafile  Long, header  MetafileHeader),PASCAL,RAW,LONG
!  GdipGetHemfFromMetafile        PROCEDURE( metafile  Long, hEmf  Long),PASCAL,RAW,LONG
!  GdipCreateMetafileFromWmf      PROCEDURE( hWmf  Long,  bDeleteWmf  Long, WmfPlaceableFileHdr  WmfPlaceableFileHeader,  metafile  Long),PASCAL,RAW,LONG
!  GdipCreateMetafileFromEmf      PROCEDURE( hEmf  Long,  bDeleteEmf  Long, metafile  Long),PASCAL,RAW,LONG
!  GdipCreateMetafileFromFile     PROCEDURE(file  String, metafile  Long),PASCAL,RAW,LONG
!  GdipCreateMetafileFromWmfFile  PROCEDURE( file  String, WmfPlaceableFileHdr  WmfPlaceableFileHeader, metafile  Long),PASCAL,RAW,LONG
!  GdipRecordMetafile             PROCEDURE( referenceHdc  Long, etype  EmfType, frameRect  RECTF,  frameUnit  MetafileFrameUnit,  description  String, metafile  Long),PASCAL,RAW,LONG
!  GdipRecordMetafileI            PROCEDURE( referenceHdc  Long, etype  EmfType, frameRect  RECTL,  frameUnit  MetafileFrameUnit,  description  String, metafile  Long),PASCAL,RAW,LONG
!  GdipRecordMetafileFileName     PROCEDURE( filename  String,  referenceHdc  Long, etype  EmfType, frameRect  RECTF,  frameUnit  MetafileFrameUnit,  description  String, metafile  Long),PASCAL,RAW,LONG
!  GdipRecordMetafileFileNameI    PROCEDURE( filename  String,  referenceHdc  Long, etype  EmfType, frameRect  RECTL,  frameUnit  MetafileFrameUnit,  description  String, metafile  Long),PASCAL,RAW,LONG

!  GdipSetMetafileDownLevelRasterizationLimit PROCEDURE( metafile  Long,  metafileRasterizationLimitDpi  Long),PASCAL,RAW,LONG
!  GdipGetMetafileDownLevelRasterizationLimit PROCEDURE( metafile  Long, metafileRasterizationLimitDpi  Long),PASCAL,RAW,LONG

! NOTE: These encoders/decoders functions expect an ImageCodecInfo array

!  GdipGetImageDecodersSize       PROCEDURE(numDecoders  Long, Size  Long),PASCAL,RAW,LONG
!  GdipGetImageDecoders           PROCEDURE( numDecoders  Long,  Size  Long, decoders  Any),PASCAL,RAW,LONG
!  GdipGetImageEncodersSize       PROCEDURE(numEncoders  Long, Size  Long),PASCAL,RAW,LONG
!  GdipGetImageEncoders           PROCEDURE( numEncoders  Long,  Size  Long, encoders  Any),PASCAL,RAW,LONG
!  GdipComment                    PROCEDURE(LONG ptrGraphics,  sizeData  Long, data  Any),PASCAL,RAW,LONG

!-----------------------------------------------
! Image Functions (No Streaming)
!-----------------------------------------------

GdipLoadImageFromFile       PROCEDURE(LONG filename, LONG PtrImage),PASCAL,LONG,RAW
GdipDisposeImage            PROCEDURE(LONG ptrImage),PASCAL,LONG,RAW

! NOTE: The encoderParams parameter expects a EncoderParameters struct or a NULL

!  GdipSaveImageToFile           PROCEDURE(LONG ptrImage, filename  String, clsidEncoder  CLSID, encoderParams  Any),PASCAL,RAW,LONG
!  GdipSaveAdd                   PROCEDURE(LONG ptrImage, encoderParams  EncoderParameters),PASCAL,RAW,LONG
!  GdipSaveAddImage              PROCEDURE(LONG ptrImage, newImage  Long, encoderParams  EncoderParameters),PASCAL,RAW,LONG

GdipGetImageGraphicsContext PROCEDURE(LONG ptrImage, LONG ptrGraphics),PASCAL,RAW,LONG
GdipGetImageBounds          PROCEDURE(LONG ptrImage, LoNG srcRectf, Enum:GpUnit srcUnit),PASCAL,RAW,LONG
GdipGetImageDimension       PROCEDURE(LONG ptrImage, SREAL rWidth, SREAL rHeight),PASCAL,RAW,LONG
GdipGetImageType            PROCEDURE(LONG ptrImage, Enum:ImageType itype),PASCAL,RAW,LONG

GdipGetImageWidth           PROCEDURE(LONG ptrImage, LONG ImgWidth),PASCAL,LONG,RAW
GdipGetImageHeight          PROCEDURE(LONG ptrImage, LONG ImgHeight),PASCAL,LONG,RAW

!  GdipGetImageHorizontalResolution PROCEDURE(LONG ptrImage, resolution  SREAL),PASCAL,RAW,LONG
!  GdipGetImageVerticalResolution   PROCEDURE(LONG ptrImage, resolution  SREAL),PASCAL,RAW,LONG
!  GdipGetImageFlags                PROCEDURE(LONG ptrImage, flags  Long),PASCAL,RAW,LONG
!  GdipGetImageRawFormat            PROCEDURE(LONG ptrImage, format  CLSID),PASCAL,RAW,LONG
!  GdipGetImagePixelFormat          PROCEDURE(LONG ptrImage, PixelFormat  Long),PASCAL,RAW,LONG
!  GdipGetImageThumbnail            PROCEDURE(LONG ptrImage, thumbWidth  Long,  thumbHeight  Long, thumbImage  Long, Optional  callback  Long = 0, Optional  callbackData  Long = 0),PASCAL,RAW,LONG
!  GdipGetEncoderParameterListSize  PROCEDURE(LONG ptrImage, clsidEncoder  CLSID, Size  Long),PASCAL,RAW,LONG
!  GdipGetEncoderParameterList      PROCEDURE(LONG ptrImage, clsidEncoder  CLSID,  Size  Long, buffer  EncoderParameters),PASCAL,RAW,LONG
!  GdipImageGetFrameDimensionsCount PROCEDURE(LONG ptrImage, LONG countPoint),PASCAL,RAW,LONG
!  GdipImageGetFrameDimensionsList  PROCEDURE(LONG ptrImage, dimensionIDs  CLSID,  LONG countPoint),PASCAL,RAW,LONG
!  GdipImageGetFrameCount           PROCEDURE(LONG ptrImage, dimensionID  CLSID, LONG countPoint),PASCAL,RAW,LONG
!  GdipImageSelectActiveFrame       PROCEDURE(LONG ptrImage, dimensionID  CLSID,  frameIndex  Long),PASCAL,RAW,LONG
!  GdipImageRotateFlip              PROCEDURE(LONG ptrImage, rfType  RotateFlipType),PASCAL,RAW,LONG
!  GdipGetImagePalette              PROCEDURE(LONG ptrImage, palette  ColorPalette,  Size  Long),PASCAL,RAW,LONG
!  GdipSetImagePalette              PROCEDURE(LONG ptrImage, palette  ColorPalette),PASCAL,RAW,LONG
!  GdipGetImagePaletteSize          PROCEDURE(LONG ptrImage, Size  Long),PASCAL,RAW,LONG
!  GdipGetPropertyCount             PROCEDURE(LONG ptrImage, numOfProperty  Long),PASCAL,RAW,LONG
!  GdipGetPropertyIdList            PROCEDURE(LONG ptrImage, numOfProperty  Long, list  Long),PASCAL,RAW,LONG
!  GdipGetPropertyItemSize          PROCEDURE(LONG ptrImage, propId  Long, Size  Long),PASCAL,RAW,LONG
!  GdipGetPropertyItem              PROCEDURE(LONG ptrImage, propId  Long,  propSize  Long, buffer  PropertyItem),PASCAL,RAW,LONG
!  GdipGetPropertySize              PROCEDURE(LONG ptrImage, totalBufferSize  Long, numProperties  Long),PASCAL,RAW,LONG
!  GdipGetAllPropertyItems          PROCEDURE(LONG ptrImage, totalBufferSize  Long,  numProperties  Long, allItems  PropertyItem),PASCAL,RAW,LONG
!  GdipRemovePropertyItem           PROCEDURE(LONG ptrImage, propId  Long),PASCAL,RAW,LONG
!  GdipSetPropertyItem              PROCEDURE(LONG ptrImage, item  PropertyItem),PASCAL,RAW,LONG
!  GdipImageForceValidation         PROCEDURE(LONG ptrImage),PASCAL,RAW,LONG

!-----------------------------------------------
! Pen Functions (ALL)
!-----------------------------------------------

GdipCreatePen1           PROCEDURE(LONG ColorPen, SREAL WidthPen, Enum:GpUnit Unit, LONG ptrPen),PASCAL,LONG,RAW              !  
GdipCreatePen2           PROCEDURE(LONG ptrBrush, SREAL rWidth,   Enum:GpUnit Unit, LONG ptrPen),PASCAL,RAW,LONG
GdipClonePen             PROCEDURE(LONG ptrPen,   LONG ptrClonePen),PASCAL,RAW,LONG
GdipDeletePen            PROCEDURE(LONG ptrPen),PASCAL,LONG,RAW                                                          !  

GdipSetPenWidth          PROCEDURE(LONG ptrPen, SREAL WidthPen),PASCAL,LONG,RAW          !   
GdipGetPenWidth          PROCEDURE(LONG ptrPen, SREAL WidthPen),PASCAL,LONG,RAW          !   

GdipSetPenUnit           PROCEDURE(LONG ptrPen, Enum:GpUnit Unit),PASCAL,RAW,LONG
GdipGetPenUnit           PROCEDURE(LONG ptrPen, Enum:GpUnit Unit),PASCAL,RAW,LONG

GdipSetPenLineCap        PROCEdURE(LONG ptrPen, Enum:LineCap startCap, Enum:LineCap endCap, Enum:DashCap dcap),PASCAL,RAW,LONG,NAME('GdipSetPenLineCap197819')

GdipSetPenStartCap       PROCEDURE(LONG ptrPen, Enum:LineCap StartCap),PASCAL,RAW,LONG  !    
GdipGetPenStartCap       PROCEDURE(LONG ptrPen, Enum:LineCap ptrStartCap),PASCAL,RAW,LONG

GdipSetPenEndCap         PROCEDURE(LONG ptrPen, Enum:LineCap EndCap),PASCAL,LONG,RAW    !    
GdipGetPenEndCap         PROCEDURE(LONG ptrPen, Enum:LineCap ptrEndCap),PASCAL,RAW,LONG

GdipSetPenDashCap        PROCEDURE(LONG ptrPen, Enum:DashCap dcap),PASCAL,RAW,LONG,NAME('GdipSetPenDashCap197819')
GdipGetPenDashCap        PROCEDURE(LONG ptrPen, Enum:DashCap ptrdcap),PASCAL,RAW,LONG,NAME('GdipGetPenDashCap197819')

GdipSetPenLineJoin       PROCEDURE(LONG ptrPen, Enum:LineJoin LnJoin),PASCAL,RAW,LONG
GdipGetPenLineJoin       PROCEDURE(LONG ptrPen, Enum:LineJoin ptrLnJoin),PASCAL,RAW,LONG

GdipSetPenCustomStartCap PROCEDURE(LONG ptrPen, LONG customCap),PASCAL,RAW,LONG
GdipGetPenCustomStartCap PROCEDURE(LONG ptrPen, LONG ptrCustomCap),PASCAL,RAW,LONG

GdipSetPenCustomEndCap   PROCEDURE(LONG ptrPen,  LONG customCap),PASCAL,RAW,LONG
GdipGetPenCustomEndCap   PROCEDURE(LONG ptrPen,  LONG ptrCustomCap),PASCAL,RAW,LONG

GdipSetPenMiterLimit     PROCEDURE(LONG ptrPen,  SREAL miterLimit),PASCAL,RAW,LONG
GdipGetPenMiterLimit     PROCEDURE(LONG ptrPen,  SREAL ptrMiterLimit),PASCAL,RAW,LONG

GdipSetPenMode           PROCEDURE(LONG ptrPen, Enum:PenAlignment penMode),PASCAL,RAW,LONG
GdipGetPenMode           PROCEDURE(LONG ptrPen, Enum:PenAlignment ptrPenMode),PASCAL,RAW,LONG

GdipSetPenTransform      PROCEDURE(LONG ptrPen,  LONG ptrMatrix),PASCAL,RAW,LONG
GdipGetPenTransform      PROCEDURE(LONG ptrPen,  LONG ptrMatrix),PASCAL,RAW,LONG
GdipResetPenTransform    PROCEDURE(LONG ptrPen),PASCAL,RAW,LONG
GdipMultiplyPenTransform PROCEDURE(LONG ptrPen,  LONG ptrMatrix,      Enum:MatrixOrder OrderTransform),PASCAL,RAW,LONG
GdipTranslatePenTransform PROCEDURE(LONG ptrPen, SREAL dx, SREAL dy,  Enum:MatrixOrder OrderTransform),PASCAL,RAW,LONG
GdipScalePenTransform    PROCEDURE(LONG ptrPen,  SREAL sx, SREAL sy,  Enum:MatrixOrder OrderTransform),PASCAL,RAW,LONG
GdipRotatePenTransform   PROCEDURE(LONG ptrPen,  SREAL pAngle,        Enum:MatrixOrder OrderTransform),PASCAL,RAW,LONG

GdipSetPenColor          PROCEDURE(LONG ptrPen, Enum:Colors ColorPen),PASCAL,LONG,RAW     !  
GdipGetPenColor          PROCEDURE(LONG ptrPen, Enum:Colors ptrColorPen),PASCAL,RAW,LONG

GdipSetPenBrushFill      PROCEDURE(LONG ptrPen, LONG ptrBrush),PASCAL,RAW,LONG
GdipGetPenBrushFill      PROCEDURE(LONG ptrPen, LONG ptrBrush),PASCAL,RAW,LONG
GdipGetPenFillType       PROCEDURE(LONG ptrPen, Enum:PenType ptype),PASCAL,RAW,LONG

GdipGetPenDashStyle      PROCEDURE(LONG ptrPen, Enum:DashStyle dStyle),PASCAL,RAW,LONG
GdipSetPenDashStyle      PROCEDURE(LONG ptrPen, Enum:DashStyle dStyle),PASCAL,RAW,LONG
GdipGetPenDashOffset     PROCEDURE(LONG ptrPen, SREAL offset),PASCAL,RAW,LONG
GdipSetPenDashOffset     PROCEDURE(LONG ptrPen, SREAL offset),PASCAL,RAW,LONG
GdipGetPenDashCount      PROCEDURE(LONG ptrPen, LONG countPoint),PASCAL,RAW,LONG

GdipSetPenDashArray      PROCEDURE(LONG ptrPen, LONG ptrArrDashValues, LONG ptrSRealSizeArrDash),PASCAL,LONG,RAW
GdipGetPenDashArray      PROCEDURE(LONG ptrPen, SREAL dash,  LONG countPoint),PASCAL,RAW,LONG

GdipGetPenCompoundCount  PROCEDURE(LONG ptrPen, LONG countPoint),PASCAL,RAW,LONG
GdipSetPenCompoundArray  PROCEDURE(LONG ptrPen, dash  SREAL,  LONG countPoint),PASCAL,RAW,LONG
GdipGetPenCompoundArray  PROCEDURE(LONG ptrPen, dash  SREAL,  LONG countPoint),PASCAL,RAW,LONG

!-----------------------------------------------
! CustomLineCap Functions (ALL)
!-----------------------------------------------

!  GdipCreateCustomLineCap        PROCEDURE( fillPath  Long,  strokePath  Long,  baseCap  LineCap,  baseInset  SREAL, customCap  Long),PASCAL,RAW,LONG
!  GdipDeleteCustomLineCap        PROCEDURE( customCap  Long),PASCAL,RAW,LONG
!  GdipCloneCustomLineCap         PROCEDURE( customCap  Long, clonedCap  Long),PASCAL,RAW,LONG
!  GdipGetCustomLineCapType       PROCEDURE( customCap  Long, capType  CustomLineCapType),PASCAL,RAW,LONG
!  GdipSetCustomLineCapStrokeCaps PROCEDURE( customCap  Long, startCap  LineCap, endCap  LineCap),PASCAL,RAW,LONG
!  GdipGetCustomLineCapStrokeCaps PROCEDURE( customCap  Long, startCap  LineCap, endCap  LineCap),PASCAL,RAW,LONG
!  GdipSetCustomLineCapStrokeJoin PROCEDURE( customCap  Long, LnJoin  LineJoin),PASCAL,RAW,LONG
!  GdipGetCustomLineCapStrokeJoin PROCEDURE( customCap  Long, LnJoin  LineJoin),PASCAL,RAW,LONG
!  GdipSetCustomLineCapBaseCap    PROCEDURE( customCap  Long, baseCap  LineCap),PASCAL,RAW,LONG
!  GdipGetCustomLineCapBaseCap    PROCEDURE( customCap  Long, baseCap  LineCap),PASCAL,RAW,LONG
!  GdipSetCustomLineCapBaseInset  PROCEDURE( customCap  Long, inset  SREAL),PASCAL,RAW,LONG
!  GdipGetCustomLineCapBaseInset  PROCEDURE( customCap  Long, inset  SREAL),PASCAL,RAW,LONG
!  GdipSetCustomLineCapWidthScale PROCEDURE( customCap  Long, widthScale  SREAL),PASCAL,RAW,LONG
!  GdipGetCustomLineCapWidthScale PROCEDURE( customCap  Long, widthScale  SREAL),PASCAL,RAW,LONG

!-----------------------------------------------
! AdjustableArrowCap Functions (ALL)
!-----------------------------------------------

!  GdipCreateAdjustableArrowCap         PROCEDURE( SREAL rHeight,  SREAL rWidth,  isFilled  Long, cap  Long),PASCAL,RAW,LONG
!  GdipSetAdjustableArrowCapHeight      PROCEDURE( cap  Long, SREAL rHeight),PASCAL,RAW,LONG
!  GdipGetAdjustableArrowCapHeight      PROCEDURE( cap  Long, SREAL rHeight),PASCAL,RAW,LONG
!  GdipSetAdjustableArrowCapWidth       PROCEDURE( cap  Long, SREAL rWidth),PASCAL,RAW,LONG
!  GdipGetAdjustableArrowCapWidth       PROCEDURE( cap  Long, SREAL rWidth),PASCAL,RAW,LONG
!  GdipSetAdjustableArrowCapMiddleInset PROCEDURE( cap  Long, middleInset  SREAL),PASCAL,RAW,LONG
!  GdipGetAdjustableArrowCapMiddleInset PROCEDURE( cap  Long, middleInset  SREAL),PASCAL,RAW,LONG
!  GdipSetAdjustableArrowCapFillState   PROCEDURE( cap  Long, bFillState  Long),PASCAL,RAW,LONG
!  GdipGetAdjustableArrowCapFillState   PROCEDURE( cap  Long, bFillState  Long),PASCAL,RAW,LONG

!-----------------------------------------------
! Bitmap Functions (No Streaming)
!-----------------------------------------------

!  GdipCreateBitmapFromFile              PROCEDURE( filename  Long, bitmap  Long),PASCAL,RAW,LONG

! NOTE: The scan0 parameter is treated as a byte array

!  GdipCreateBitmapFromScan0             PROCEDURE( LONG rWidth,  LONG rHeight,  stride  Long,  PixelFormat  Long, scan0  Any, bitmap  Long),PASCAL,RAW,LONG
!  GdipCreateBitmapFromGraphics          PROCEDURE( LONG rWidth,  LONG rHeight,  target  Long, bitmap  Long),PASCAL,RAW,LONG

! NOTE: DirectX required for this function

!  GdipCreateBitmapFromDirectDrawSurface PROCEDURE(surface  DirectDrawSurface7, bitmap  Long),PASCAL,RAW,LONG

!  GdipCreateBitmapFromGdiDib            PROCEDURE(gdiBitmapInfo  BITMAPINFO,  gdiBitmapData  Long, bitmap  Long),PASCAL,RAW,LONG
!  GdipCreateBitmapFromHBITMAP           PROCEDURE( hbm  Long,  hpal  Long, bitmap  Long),PASCAL,RAW,LONG
!  GdipCreateHBITMAPFromBitmap           PROCEDURE( bitmap  Long, hbmReturn  Long,  background  Long),PASCAL,RAW,LONG
!  GdipCreateBitmapFromHICON             PROCEDURE( hicon  Long, bitmap  Long),PASCAL,RAW,LONG
!  GdipCreateHICONFromBitmap             PROCEDURE( bitmap  Long, hbmReturn  Long),PASCAL,RAW,LONG
!  GdipCreateBitmapFromResource          PROCEDURE( hInstance  Long,  lpBitmapName  String, bitmap  Long),PASCAL,RAW,LONG
!  GdipCloneBitmapArea                   PROCEDURE( SREAL x,  SREAL y,  SREAL rWidth,  SREAL rHeight,  PixelFormat  Long,  srcBitmap  Long, dstBitmap  Long),PASCAL,RAW,LONG
!  GdipCloneBitmapAreaI                  PROCEDURE( LONG x,  LONG y,  LONG rWidth,  LONG rHeight,  PixelFormat  Long,  srcBitmap  Long, dstBitmap  Long),PASCAL,RAW,LONG
!  GdipBitmapLockBits                    PROCEDURE( bitmap  Long, LONG ptrRectL,  flags  Long,  PixelFormat  Long, lockedBitmapData  BitmapData),PASCAL,RAW,LONG
!  GdipBitmapUnlockBits                  PROCEDURE( bitmap  Long, lockedBitmapData  BitmapData),PASCAL,RAW,LONG
!  GdipBitmapGetPixel                    PROCEDURE( bitmap  Long,  LONG x,  LONG y, color  Long),PASCAL,RAW,LONG
!  GdipBitmapSetPixel                    PROCEDURE( bitmap  Long,  LONG x,  LONG y,  color  Long),PASCAL,RAW,LONG
!  GdipBitmapSetResolution               PROCEDURE( bitmap  Long,  xdpi  SREAL,  ydpi  SREAL),PASCAL,RAW,LONG

!-----------------------------------------------
! CachedBitmap Functions (ALL)
!-----------------------------------------------

!  GdipCreateCachedBitmap                PROCEDURE( bitmap  Long, LONG ptrGraphics, cachedBitmap  Long),PASCAL,RAW,LONG
!  GdipDeleteCachedBitmap                PROCEDURE( cachedBitmap  Long),PASCAL,RAW,LONG
!  GdipDrawCachedBitmap                  PROCEDURE(LONG ptrGraphics,  cachedBitmap  Long,  LONG x,  LONG y),PASCAL,RAW,LONG

!-----------------------------------------------
! Brush Functions (ALL)
!-----------------------------------------------

GdipCloneBrush         PROCEDURE(LONG ptrBrush, Long cloneBrush),PASCAL,RAW,LONG
GdipDeleteBrush        PROCEDURE(LONG ptrBrush),PASCAL,RAW,LONG                  !   GDI+
GdipGetBrushType       PROCEDURE(LONG ptrBrush, Enum:BrushType brshType),PASCAL,RAW,LONG

!-----------------------------------------------
! HatchBrush Functions (ALL)
!-----------------------------------------------

GdipCreateHatchBrush   PROCEDURE(LONG StyleHatchBrush, LONG ForeColor, LONG BackColor, LONG ptrBrush),PASCAL,RAW,LONG  !   GDI+
GdipGetHatchStyle      PROCEDURE(LONG ptrBrush, Enum:HatchStyle style),PASCAL,RAW,LONG
GdipGetHatchForegroundColor PROCEDURE( LONG ptrBrush, LONG forecolr),PASCAL,RAW,LONG
GdipGetHatchBackgroundColor PROCEDURE( LONG ptrBrush, LONG backcolr),PASCAL,RAW,LONG

!-----------------------------------------------
! SolidBrush Functions (ALL)
!-----------------------------------------------

GdipCreateSolidFill    PROCEDURE(LONG argb, LONG ptrBrush),PASCAL,RAW,LONG
GdipSetSolidFillColor  PROCEDURE(LONG ptrBrush, LONG ptrArgb),PASCAL,RAW,LONG
GdipGetSolidFillColor  PROCEDURE(LONG ptrBrush, LONG ptrArgb),PASCAL,RAW,LONG

!-----------------------------------------------
! LineBrush Functions (ALL)
!-----------------------------------------------

!  GdipCreateLineBrush                   PROCEDURE(point1  POINTF, point2  POINTF,  color1  Long,  color2  Long,  WrapMd  WrapMode, lineGradient  Long),PASCAL,RAW,LONG
!  GdipCreateLineBrushI                  PROCEDURE(point1  POINTL, point2  POINTL,  color1  Long,  color2  Long,  WrapMd  WrapMode, lineGradient  Long),PASCAL,RAW,LONG
!  GdipCreateLineBrushFromRect           PROCEDURE(LONG ptrRectF,  color1  Long,  color2  Long,  mode  LinearGradientMode,  WrapMd  WrapMode, lineGradient  Long),PASCAL,RAW,LONG
!  GdipCreateLineBrushFromRectI          PROCEDURE(LONG ptrRectL,  color1  Long,  color2  Long,  mode  LinearGradientMode,  WrapMd  WrapMode, lineGradient  Long),PASCAL,RAW,LONG
!  GdipCreateLineBrushFromRectWithAngle  PROCEDURE(LONG ptrRectF,  color1  Long,  color2  Long,  angle  SREAL,  isAngleScalable  Long,  WrapMd  WrapMode, lineGradient  Long),PASCAL,RAW,LONG
!  GdipCreateLineBrushFromRectWithAngleI PROCEDURE(LONG ptrRectL,  color1  Long,  color2  Long,  angle  SREAL,  isAngleScalable  Long,  WrapMd  WrapMode, lineGradient  Long),PASCAL,RAW,LONG
!  GdipSetLineColors                     PROCEDURE( LONG ptrBrush,  color1  Long,  color2  Long),PASCAL,RAW,LONG
!  GdipGetLineColors                     PROCEDURE( LONG ptrBrush, lColors  Long),PASCAL,RAW,LONG
!  GdipGetLineRect                       PROCEDURE( LONG ptrBrush, LONG ptrRectF),PASCAL,RAW,LONG
!  GdipGetLineRectI                      PROCEDURE( LONG ptrBrush, LONG ptrRectL),PASCAL,RAW,LONG
!  GdipSetLineGammaCorrection            PROCEDURE( LONG ptrBrush,  useGammaCorrection  Long),PASCAL,RAW,LONG
!  GdipGetLineGammaCorrection            PROCEDURE( LONG ptrBrush, useGammaCorrection  Long),PASCAL,RAW,LONG
!  GdipGetLineBlendCount                 PROCEDURE( LONG ptrBrush, LONG countPoint),PASCAL,RAW,LONG
!  GdipGetLineBlend                      PROCEDURE( LONG ptrBrush, blend  SREAL, positions  SREAL,  LONG countPoint),PASCAL,RAW,LONG
!  GdipSetLineBlend                      PROCEDURE( LONG ptrBrush, blend  SREAL, positions  SREAL,  LONG countPoint),PASCAL,RAW,LONG
!  GdipGetLinePresetBlendCount           PROCEDURE( LONG ptrBrush, LONG countPoint),PASCAL,RAW,LONG
!  GdipGetLinePresetBlend                PROCEDURE( LONG ptrBrush, blend  Long, positions  SREAL,  LONG countPoint),PASCAL,RAW,LONG
!  GdipSetLinePresetBlend                PROCEDURE( LONG ptrBrush, blend  Long, positions  SREAL,  LONG countPoint),PASCAL,RAW,LONG
!  GdipSetLineSigmaBlend                 PROCEDURE( LONG ptrBrush, focus  SREAL,  theScale  SREAL),PASCAL,RAW,LONG
!  GdipSetLineLinearBlend                PROCEDURE( LONG ptrBrush, focus  SREAL,  theScale  SREAL),PASCAL,RAW,LONG
!  GdipSetLineWrapMode                   PROCEDURE( LONG ptrBrush, WrapMd  WrapMode),PASCAL,RAW,LONG
!  GdipGetLineWrapMode                   PROCEDURE( LONG ptrBrush, WrapMd  WrapMode),PASCAL,RAW,LONG
!  GdipGetLineTransform                  PROCEDURE( LONG ptrBrush, LONG ptrMatrix  ),PASCAL,RAW,LONG
!  GdipSetLineTransform                  PROCEDURE( LONG ptrBrush, LONG ptrMatrix  ),PASCAL,RAW,LONG
!  GdipResetLineTransform                PROCEDURE( LONG ptrBrush),PASCAL,RAW,LONG
!  GdipMultiplyLineTransform             PROCEDURE( LONG ptrBrush, LONG ptrMatrix  ,  Enum:MatrixOrder OrderTransform),PASCAL,RAW,LONG
!  GdipTranslateLineTransform            PROCEDURE( LONG ptrBrush, SREAL dx,  SREAL dy,  Enum:MatrixOrder OrderTransform),PASCAL,RAW,LONG
!  GdipScaleLineTransform                PROCEDURE( LONG ptrBrush, sx  SREAL,  sy  SREAL,  Enum:MatrixOrder OrderTransform),PASCAL,RAW,LONG
!  GdipRotateLineTransform               PROCEDURE( LONG ptrBrush, angle  SREAL,  Enum:MatrixOrder OrderTransform),PASCAL,RAW,LONG

!-----------------------------------------------
! TextureBrush Functions (ALL)
!-----------------------------------------------

!  GdipCreateTexture                     PROCEDURE(LONG ptrImage,  WrapMd  WrapMode, texture  Long),PASCAL,RAW,LONG
!  GdipCreateTexture2                    PROCEDURE(LONG ptrImage,  WrapMd  WrapMode,  SREAL x,  SREAL y,  SREAL rWidth,  SREAL rHeight, texture  Long),PASCAL,RAW,LONG
!  GdipCreateTextureIA                   PROCEDURE(LONG ptrImage,  imageAttributes  Long,  SREAL x,  SREAL y,  SREAL rWidth,  SREAL rHeight, texture  Long),PASCAL,RAW,LONG
!  GdipCreateTexture2I                   PROCEDURE(LONG ptrImage,  WrapMd  WrapMode,  LONG x,  LONG y,  LONG rWidth,  LONG rHeight, texture  Long),PASCAL,RAW,LONG
!  GdipCreateTextureIAI                  PROCEDURE(LONG ptrImage,  imageAttributes  Long,  LONG x,  LONG y,  LONG rWidth,  LONG rHeight, texture  Long),PASCAL,RAW,LONG
!  GdipGetTextureTransform               PROCEDURE( LONG ptrBrush, LONG ptrMatrix  ),PASCAL,RAW,LONG
!  GdipSetTextureTransform               PROCEDURE( LONG ptrBrush, LONG ptrMatrix  ),PASCAL,RAW,LONG
!  GdipResetTextureTransform             PROCEDURE( LONG ptrBrush),PASCAL,RAW,LONG
!  GdipTranslateTextureTransform         PROCEDURE( LONG ptrBrush, SREAL dx,  SREAL dy,  Enum:MatrixOrder OrderTransform),PASCAL,RAW,LONG
!  GdipMultiplyTextureTransform          PROCEDURE( LONG ptrBrush, LONG ptrMatrix  ,  Enum:MatrixOrder OrderTransform),PASCAL,RAW,LONG
!  GdipScaleTextureTransform             PROCEDURE( LONG ptrBrush, sx  SREAL,  sy  SREAL,  Enum:MatrixOrder OrderTransform),PASCAL,RAW,LONG
!  GdipRotateTextureTransform            PROCEDURE( LONG ptrBrush, angle  SREAL,  Enum:MatrixOrder OrderTransform),PASCAL,RAW,LONG
!  GdipSetTextureWrapMode                PROCEDURE( LONG ptrBrush, WrapMd  WrapMode),PASCAL,RAW,LONG
!  GdipGetTextureWrapMode                PROCEDURE( LONG ptrBrush, WrapMd  WrapMode),PASCAL,RAW,LONG
!  GdipGetTextureImage                   PROCEDURE( LONG ptrBrush, LONG ptrImage),PASCAL,RAW,LONG

!-----------------------------------------------
! PathGradientBrush Functions (ALL)
!-----------------------------------------------

!  GdipCreatePathGradient                 PROCEDURE(LONG ptrPointF, LONG countPoint,  WrapMd  WrapMode, polyGradient  Long),PASCAL,RAW,LONG
!  GdipCreatePathGradientI                PROCEDURE(LONG ptrPointL, LONG countPoint,  WrapMd  WrapMode, polyGradient  Long),PASCAL,RAW,LONG
!  GdipCreatePathGradientFromPath         PROCEDURE( LONG ptrPath, polyGradient  Long),PASCAL,RAW,LONG
!  GdipGetPathGradientCenterColor         PROCEDURE( LONG ptrBrush, lColors  Long),PASCAL,RAW,LONG
!  GdipSetPathGradientCenterColor         PROCEDURE( LONG ptrBrush, lColors  Long),PASCAL,RAW,LONG
!  GdipGetPathGradientSurroundColorsWithCount PROCEDURE( LONG ptrBrush, argb  Long, LONG countPoint),PASCAL,RAW,LONG
!  GdipSetPathGradientSurroundColorsWithCount PROCEDURE( LONG ptrBrush, argb  Long, LONG countPoint),PASCAL,RAW,LONG
!  GdipGetPathGradientPath               PROCEDURE( LONG ptrBrush, LONG ptrPath),PASCAL,RAW,LONG
!  GdipSetPathGradientPath               PROCEDURE( LONG ptrBrush, LONG ptrPath),PASCAL,RAW,LONG
!  GdipGetPathGradientCenterPoint        PROCEDURE( LONG ptrBrush, LONG ptrPointF),PASCAL,RAW,LONG
!  GdipGetPathGradientCenterPointI       PROCEDURE( LONG ptrBrush, LONG ptrPointL),PASCAL,RAW,LONG
!  GdipSetPathGradientCenterPoint        PROCEDURE( LONG ptrBrush, LONG ptrPointF),PASCAL,RAW,LONG
!  GdipSetPathGradientCenterPointI       PROCEDURE( LONG ptrBrush, LONG ptrPointL),PASCAL,RAW,LONG
!  GdipGetPathGradientRect               PROCEDURE( LONG ptrBrush, LONG ptrRectF),PASCAL,RAW,LONG
!  GdipGetPathGradientRectI              PROCEDURE( LONG ptrBrush, LONG ptrRectL),PASCAL,RAW,LONG
!  GdipGetPathGradientPointCount         PROCEDURE( LONG ptrBrush, LONG countPoint),PASCAL,RAW,LONG
!  GdipGetPathGradientSurroundColorCount PROCEDURE( LONG ptrBrush, LONG countPoint),PASCAL,RAW,LONG
!  GdipSetPathGradientGammaCorrection    PROCEDURE( LONG ptrBrush, useGammaCorrection  Long),PASCAL,RAW,LONG
!  GdipGetPathGradientGammaCorrection    PROCEDURE( LONG ptrBrush, useGammaCorrection  Long),PASCAL,RAW,LONG
!  GdipGetPathGradientBlendCount         PROCEDURE( LONG ptrBrush, LONG countPoint),PASCAL,RAW,LONG
!  GdipGetPathGradientBlend              PROCEDURE( LONG ptrBrush, blend  SREAL, positions  SREAL,  LONG countPoint),PASCAL,RAW,LONG
!  GdipSetPathGradientBlend              PROCEDURE( LONG ptrBrush, blend  SREAL, positions  SREAL,  LONG countPoint),PASCAL,RAW,LONG
!  GdipGetPathGradientPresetBlendCount   PROCEDURE( LONG ptrBrush, LONG countPoint),PASCAL,RAW,LONG
!  GdipGetPathGradientPresetBlend        PROCEDURE( LONG ptrBrush, blend  Long, positions  SREAL,  LONG countPoint),PASCAL,RAW,LONG
!  GdipSetPathGradientPresetBlend        PROCEDURE( LONG ptrBrush, blend  Long, positions  SREAL,  LONG countPoint),PASCAL,RAW,LONG
!  GdipSetPathGradientSigmaBlend         PROCEDURE( LONG ptrBrush, focus  SREAL,  sscale  SREAL),PASCAL,RAW,LONG
!  GdipSetPathGradientLinearBlend        PROCEDURE( LONG ptrBrush, focus  SREAL,  sscale  SREAL),PASCAL,RAW,LONG
!  GdipGetPathGradientWrapMode           PROCEDURE( LONG ptrBrush, WrapMd  WrapMode),PASCAL,RAW,LONG
!  GdipSetPathGradientWrapMode           PROCEDURE( LONG ptrBrush, WrapMd  WrapMode),PASCAL,RAW,LONG
!  GdipGetPathGradientTransform          PROCEDURE( LONG ptrBrush, LONG ptrMatrix  ),PASCAL,RAW,LONG
!  GdipSetPathGradientTransform          PROCEDURE( LONG ptrBrush, LONG ptrMatrix  ),PASCAL,RAW,LONG
!  GdipResetPathGradientTransform        PROCEDURE( LONG ptrBrush),PASCAL,RAW,LONG
!  GdipMultiplyPathGradientTransform     PROCEDURE( LONG ptrBrush, LONG ptrMatrix  ,  Enum:MatrixOrder OrderTransform),PASCAL,RAW,LONG
!  GdipTranslatePathGradientTransform    PROCEDURE( LONG ptrBrush, SREAL dx,  SREAL dy,  Enum:MatrixOrder OrderTransform),PASCAL,RAW,LONG
!  GdipScalePathGradientTransform        PROCEDURE( LONG ptrBrush, sx  SREAL,  sy  SREAL,  Enum:MatrixOrder OrderTransform),PASCAL,RAW,LONG
!  GdipRotatePathGradientTransform       PROCEDURE( LONG ptrBrush, angle  SREAL,  Enum:MatrixOrder OrderTransform),PASCAL,RAW,LONG
!  GdipGetPathGradientFocusScales        PROCEDURE( LONG ptrBrush, xScale  SREAL, yScale  SREAL),PASCAL,RAW,LONG
!  GdipSetPathGradientFocusScales        PROCEDURE( LONG ptrBrush, xScale  SREAL,  yScale  SREAL),PASCAL,RAW,LONG

!-----------------------------------------------
! GraphicsPath Functions (ALL)
!-----------------------------------------------

!  GdipCreatePath                    PROCEDURE(Enum:FillMode brushmode, LONG ptrPath),PASCAL,RAW,LONG

! NOTE: The types parameter is treated as a byte array (LONG ByteArr)

!  GdipCreatePath2                   PROCEDURE(LONG ptrPointF, types  Any,  LONG countPoint, Enum:FillMode brushmode, LONG ptrPath),PASCAL,RAW,LONG
!  GdipCreatePath2I                  PROCEDURE(LONG ptrPointL, types  Any,  LONG countPoint, Enum:FillMode brushmode, LONG ptrPath),PASCAL,RAW,LONG
!  GdipClonePath                     PROCEDURE( LONG ptrPath, clonePath  Long),PASCAL,RAW,LONG
!  GdipDeletePath                    PROCEDURE( LONG ptrPath),PASCAL,RAW,LONG
!  GdipResetPath                     PROCEDURE( LONG ptrPath),PASCAL,RAW,LONG
!  GdipGetPointCount                 PROCEDURE( LONG ptrPath, LONG countPoint),PASCAL,RAW,LONG

!  NOTE: The types parameter is treated as a byte array

!  GdipGetPathTypes                  PROCEDURE( LONG ptrPath, types  Any,  LONG countPoint),PASCAL,RAW,LONG
!  GdipGetPathPoints                 PROCEDURE( LONG ptrPath, LONG ptrPointF,  LONG countPoint),PASCAL,RAW,LONG
!  GdipGetPathPointsI                PROCEDURE( LONG ptrPath, LONG ptrPointL,  LONG countPoint),PASCAL,RAW,LONG
!  GdipGetPathFillMode               PROCEDURE( LONG ptrPath, Enum:FillMode brushmode),PASCAL,RAW,LONG
!  GdipSetPathFillMode               PROCEDURE( LONG ptrPath, Enum:FillMode brushmode),PASCAL,RAW,LONG
!  GdipGetPathData                   PROCEDURE( LONG ptrPath, pdata  PathData),PASCAL,RAW,LONG
!  GdipStartPathFigure               PROCEDURE( LONG ptrPath),PASCAL,RAW,LONG
!  GdipClosePathFigure               PROCEDURE( LONG ptrPath),PASCAL,RAW,LONG
!  GdipClosePathFigures              PROCEDURE( LONG ptrPath),PASCAL,RAW,LONG
!  GdipSetPathMarker                 PROCEDURE( LONG ptrPath),PASCAL,RAW,LONG
!  GdipClearPathMarkers              PROCEDURE( LONG ptrPath),PASCAL,RAW,LONG
!  GdipReversePath                   PROCEDURE( LONG ptrPath),PASCAL,RAW,LONG
!  GdipGetPathLastPoint              PROCEDURE( LONG ptrPath, lastPoint POINTF),PASCAL,RAW,LONG
!  GdipAddPathLine                   PROCEDURE( LONG ptrPath, SREAL x1, SREAL y1,  SREAL x2,  SREAL y2),PASCAL,RAW,LONG
!  GdipAddPathLine2                  PROCEDURE( LONG ptrPath, LONG ptrPointF,  LONG countPoint),PASCAL,RAW,LONG
!  GdipAddPathArc                    PROCEDURE( LONG ptrPath, SREAL x,  SREAL y,  SREAL rWidth,  SREAL rHeight,  SREAL StartAngle,  SREAL SweepAngle),PASCAL,RAW,LONG
!  GdipAddPathBezier                 PROCEDURE( LONG ptrPath, SREAL x1, SREAL y1,  SREAL x2,  SREAL y2,  x3  SREAL,  y3  SREAL,  x4  SREAL,  y4  SREAL),PASCAL,RAW,LONG
!  GdipAddPathBeziers                PROCEDURE( LONG ptrPath, LONG ptrPointF,  LONG countPoint),PASCAL,RAW,LONG
!  GdipAddPathCurve                  PROCEDURE( LONG ptrPath, LONG ptrPointF,  LONG countPoint),PASCAL,RAW,LONG
!  GdipAddPathCurve2                 PROCEDURE( LONG ptrPath, LONG ptrPointF,  LONG countPoint,  SREAL Tension),PASCAL,RAW,LONG
!  GdipAddPathCurve3                 PROCEDURE( LONG ptrPath, LONG ptrPointF,  LONG countPoint,  offset  Long,  numberOfSegments  Long,  SREAL Tension),PASCAL,RAW,LONG
!  GdipAddPathClosedCurve            PROCEDURE( LONG ptrPath, LONG ptrPointF,  LONG countPoint),PASCAL,RAW,LONG
!  GdipAddPathClosedCurve2           PROCEDURE( LONG ptrPath, LONG ptrPointF,  LONG countPoint,  SREAL Tension),PASCAL,RAW,LONG
!  GdipAddPathRectangle              PROCEDURE( LONG ptrPath, SREAL x,  SREAL y,  SREAL rWidth,  SREAL rHeight),PASCAL,RAW,LONG
!  GdipAddPathRectangles             PROCEDURE( LONG ptrPath, LONG ptrRectF,  LONG countPoint),PASCAL,RAW,LONG
!  GdipAddPathEllipse                PROCEDURE( LONG ptrPath, SREAL x,  SREAL y,  SREAL rWidth,  SREAL rHeight),PASCAL,RAW,LONG
!  GdipAddPathPie                    PROCEDURE( LONG ptrPath, SREAL x,  SREAL y,  SREAL rWidth,  SREAL rHeight,  SREAL StartAngle,  SREAL SweepAngle),PASCAL,RAW,LONG
!  GdipAddPathPolygon                PROCEDURE( LONG ptrPath, LONG ptrPointF,  LONG countPoint),PASCAL,RAW,LONG
!  GdipAddPathPath                   PROCEDURE( LONG ptrPath, addingPath  Long,  bConnect  Long),PASCAL,RAW,LONG
!  GdipAddPathString                 PROCEDURE( LONG ptrPath, str String,  length  Long,  family  Long,  style  Long,  emSize  SREAL, layoutRect  RECTF,  StringFormat  Long),PASCAL,RAW,LONG
!  GdipAddPathStringI                PROCEDURE( LONG ptrPath, str String,  length  Long,  family  Long,  style  Long,  emSize  SREAL, layoutRect  RECTL,  StringFormat  Long),PASCAL,RAW,LONG
!  GdipAddPathLineI                  PROCEDURE( LONG ptrPath, x1  Long,  y1  Long,  x2  Long,  y2  Long),PASCAL,RAW,LONG
!  GdipAddPathLine2I                 PROCEDURE( LONG ptrPath, LONG ptrPointL, LONG countPoint),PASCAL,RAW,LONG
!  GdipAddPathArcI                   PROCEDURE( LONG ptrPath, LONG x,  LONG y,  LONG rWidth,  LONG rHeight,  SREAL StartAngle,  SREAL SweepAngle),PASCAL,RAW,LONG
!  GdipAddPathBezierI                PROCEDURE( LONG ptrPath, x1  Long,  y1  Long,  x2  Long,  y2  Long,  x3  Long,  y3  Long,  x4  Long,  y4  Long),PASCAL,RAW,LONG
!  GdipAddPathBeziersI               PROCEDURE( LONG ptrPath, LONG ptrPointL,  LONG countPoint),PASCAL,RAW,LONG
!  GdipAddPathCurveI                 PROCEDURE( LONG ptrPath, LONG ptrPointL,  LONG countPoint),PASCAL,RAW,LONG
!  GdipAddPathCurve2I                PROCEDURE( LONG ptrPath, LONG ptrPointL,  LONG countPoint,  tension  Long),PASCAL,RAW,LONG
!  GdipAddPathCurve3I                PROCEDURE( LONG ptrPath, LONG ptrPointL,  LONG countPoint,  offset  Long,  numberOfSegments  Long,  SREAL Tension),PASCAL,RAW,LONG
!  GdipAddPathClosedCurveI           PROCEDURE( LONG ptrPath, LONG ptrPointL,  LONG countPoint),PASCAL,RAW,LONG
!  GdipAddPathClosedCurve2I          PROCEDURE( LONG ptrPath, LONG ptrPointL,  LONG countPoint,  SREAL Tension),PASCAL,RAW,LONG
!  GdipAddPathRectangleI             PROCEDURE( LONG ptrPath, LONG x,  LONG y,  LONG rWidth,  LONG rHeight),PASCAL,RAW,LONG
!  GdipAddPathRectanglesI            PROCEDURE( LONG ptrPath, rects  RECTL,  LONG countPoint),PASCAL,RAW,LONG
!  GdipAddPathEllipseI               PROCEDURE( LONG ptrPath, LONG x,  LONG y,  LONG rWidth,  LONG rHeight),PASCAL,RAW,LONG
!  GdipAddPathPieI                   PROCEDURE( LONG ptrPath, LONG x,  LONG y,  LONG rWidth,  LONG rHeight,  SREAL StartAngle,  SREAL SweepAngle),PASCAL,RAW,LONG
!  GdipAddPathPolygonI               PROCEDURE( LONG ptrPath, LONG ptrPointL,  LONG countPoint),PASCAL,RAW,LONG
!  GdipFlattenPath                   PROCEDURE( LONG ptrPath, LONG ptrMatrix  ,  flatness  SREAL),PASCAL,RAW,LONG
!  GdipWindingModeOutline            PROCEDURE( LONG ptrPath, LONG ptrMatrix  ,  flatness  SREAL),PASCAL,RAW,LONG
!  GdipWidenPath                     PROCEDURE( nativePath  Long, LONG ptrPen,  LONG ptrMatrix  ,  flatness  SREAL),PASCAL,RAW,LONG
!  GdipWarpPath                      PROCEDURE( LONG ptrPath, LONG ptrMatrix  , LONG ptrPointF,  LONG countPoint,  srcx  SREAL,  srcy  SREAL,  srcwidth  SREAL,  srcheight  SREAL,  WarpMd  WarpMode,  flatness  SREAL),PASCAL,RAW,LONG
!  GdipTransformPath                 PROCEDURE( LONG ptrPath, LONG ptrMatrix  ),PASCAL,RAW,LONG
!  GdipGetPathWorldBounds            PROCEDURE( LONG ptrPath, bounds  RECTF,  LONG ptrMatrix  , LONG ptrPen),PASCAL,RAW,LONG
!  GdipGetPathWorldBoundsI           PROCEDURE( LONG ptrPath, bounds  RECTL,  LONG ptrMatrix  , LONG ptrPen),PASCAL,RAW,LONG
!  GdipIsVisiblePathPoint            PROCEDURE( LONG ptrPath, SREAL x,  SREAL y, LONG ptrGraphics, LONG Result),PASCAL,RAW,LONG
!  GdipIsVisiblePathPointI           PROCEDURE( LONG ptrPath, LONG x,  LONG y, LONG ptrGraphics, LONG Result),PASCAL,RAW,LONG
!  GdipIsOutlineVisiblePathPoint     PROCEDURE( LONG ptrPath, SREAL x,  SREAL y, LONG ptrPen, LONG ptrGraphics, LONG Result),PASCAL,RAW,LONG
!  GdipIsOutlineVisiblePathPointI    PROCEDURE( LONG ptrPath, LONG x,  LONG y, LONG ptrPen, LONG ptrGraphics, LONG Result),PASCAL,RAW,LONG

!-----------------------------------------------
! PathIterator Functions (ALL)
!-----------------------------------------------

!  GdipCreatePathIter            PROCEDURE(iterator  Long,  LONG ptrPath),PASCAL,RAW,LONG
!  GdipDeletePathIter            PROCEDURE( iterator  Long),PASCAL,RAW,LONG
!  GdipPathIterNextSubpath       PROCEDURE( iterator  Long, resultCount  Long, startIndex  Long, endIndex  Long, isClosed  Long),PASCAL,RAW,LONG
!  GdipPathIterNextSubpathPath   PROCEDURE( iterator  Long, resultCount  Long,  LONG ptrPath, isClosed  Long),PASCAL,RAW,LONG
!  GdipPathIterNextPathType      PROCEDURE( iterator  Long, resultCount  Long, pathType  Any, startIndex  Long, endIndex  Long),PASCAL,RAW,LONG
!  GdipPathIterNextMarker        PROCEDURE( iterator  Long, resultCount  Long, startIndex  Long, endIndex  Long),PASCAL,RAW,LONG
!  GdipPathIterNextMarkerPath    PROCEDURE( iterator  Long, resultCount  Long,  LONG ptrPath),PASCAL,RAW,LONG
!  GdipPathIterGetCount          PROCEDURE( iterator  Long, LONG countPoint),PASCAL,RAW,LONG
!  GdipPathIterGetSubpathCount   PROCEDURE( iterator  Long, LONG countPoint),PASCAL,RAW,LONG
!  GdipPathIterIsValid           PROCEDURE( iterator  Long, valid  Long),PASCAL,RAW,LONG
!  GdipPathIterHasCurve          PROCEDURE( iterator  Long, hasCurve  Long),PASCAL,RAW,LONG
!  GdipPathIterRewind            PROCEDURE( iterator  Long),PASCAL,RAW,LONG

! NOTE: The types parameter is treated as a byte array

!  GdipPathIterEnumerate         PROCEDURE( iterator  Long, resultCount  Long, LONG ptrPointF, types  Any,  LONG countPoint),PASCAL,RAW,LONG
!  GdipPathIterCopyData          PROCEDURE( iterator  Long, resultCount  Long, LONG ptrPointF, types  Any,  startIndex  Long,  endIndex  Long),PASCAL,RAW,LONG

!-----------------------------------------------
! Matrix Functions (ALL)
!-----------------------------------------------
GdipCreateMatrix                 PROCEDURE(LONG ptrMatrix),PASCAL,RAW,LONG
GdipCreateMatrix2                PROCEDURE(SREAL m11, SREAL m12, SREAL m21, SREAL m22, SREAL dx, SREAL dy, LONG ptrMatrix),PASCAL,RAW,LONG
GdipCreateMatrix3                PROCEDURE(LONG ptrRECTF, LONG ptrPOINTF, LONG ptrMatrix),PASCAL,RAW,LONG
GdipCreateMatrix3I               PROCEDURE(LONG ptrRECTL, LONG ptrPOINTL, LONG ptrMatrix),PASCAL,RAW,LONG

GdipCloneMatrix                  PROCEDURE(LONG ptrMatrix, LONG ptrCloneMatrix),PASCAL,RAW,LONG
GdipDeleteMatrix                 PROCEDURE(LONG ptrMatrix),PASCAL,RAW,LONG

GdipMultiplyMatrix               PROCEDURE(LONG ptrMatrix, LONG ptrMatrix2, LONG pMatrixOrder),PASCAL,RAW,LONG
GdipTranslateMatrix              PROCEDURE(LONG ptrMatrix, SREAL offsetX , SREAL offsetY,  LONG pMatrixOrder),PASCAL,LONG
GdipScaleMatrix                  PROCEDURE(LONG ptrMatrix, SREAL scaleX, SREAL scaleY, LONG pMatrixOrder),PASCAL,RAW,LONG
GdipRotateMatrix                 PROCEDURE(LONG ptrMatrix, SREAL pAngle,  LONG pMatrixOrder),PASCAL,RAW,LONG
GdipShearMatrix                  PROCEDURE(LONG ptrMatrix, SREAL shearX, SREAL shearY, LONG pMatrixOrder),PASCAL,RAW,LONG
GdipInvertMatrix                 PROCEDURE(LONG ptrMatrix),PASCAL,RAW,LONG

GdipTransformMatrixPoints        PROCEDURE(LONG ptrMatrix, LONG ptrPOINTF, LONG count),PASCAL,RAW,LONG
GdipTransformMatrixPointsI       PROCEDURE(LONG ptrMatrix, LONG ptrPOINTL, LONG count),PASCAL,RAW,LONG
GdipVectorTransformMatrixPoints  PROCEDURE(LONG ptrMatrix, LONG ptrPOINTF, LONG count),PASCAL,RAW,LONG
GdipVectorTransformMatrixPointsI PROCEDURE(LONG ptrMatrix, LONG ptrPOINTL, LONG count),PASCAL,RAW,LONG

GdipSetMatrixElements            PROCEDURE(LONG ptrMatrix, SREAL m11, SREAL m12, SREAL m21, SREAL m22, SREAL dx, SREAL dy),PASCAL,RAW,LONG
GdipGetMatrixElements            PROCEDURE(LONG ptrMatrix, LONG ArrMatrixElem),PASCAL,RAW,LONG

GdipIsMatrixInvertible           PROCEDURE(LONG ptrMatrix, LONG result),PASCAL,RAW,LONG
GdipIsMatrixIdentity             PROCEDURE(LONG ptrMatrix, LONG result),PASCAL,RAW,LONG
GdipIsMatrixEqual                PROCEDURE(LONG ptrMatrix, LONG ptrMatrix2, LONG result),PASCAL,RAW,LONG


!-----------------------------------------------
! Region Functions (ALL)
!-----------------------------------------------

GdipCreateRegion                  PROCEDURE(LONG ptrRegion),PASCAL,RAW,LONG
GdipCreateRegionRect              PROCEDURE(LONG ptrRectF, LONG ptrRegion),PASCAL,RAW,LONG
GdipCreateRegionRectI             PROCEDURE(LONG ptrRectL, LONG ptrRegion),PASCAL,RAW,LONG
GdipCreateRegionPath              PROCEDURE( LONG ptrPath, LONG ptrRegion),PASCAL,RAW,LONG

!-----------------------------------------------
! NOTE: The regionData parameter is treated as a byte array
!-----------------------------------------------

GdipCreateRegionRgnData            PROCEDURE(LONG ptrRegionData, LONG Size, LONG ptrRegion),PASCAL,RAW,LONG

!  GdipCreateRegionHrgn              PROCEDURE( LONG hRgn, LONG ptrRegion),PASCAL,RAW,LONG
!  GdipCloneRegion                   PROCEDURE( LONG ptrRegion, cloneRegion  Long),PASCAL,RAW,LONG
!  GdipDeleteRegion                  PROCEDURE( LONG ptrRegion),PASCAL,RAW,LONG
!  GdipSetInfinite                   PROCEDURE( LONG ptrRegion),PASCAL,RAW,LONG
!  GdipSetEmpty                      PROCEDURE( LONG ptrRegion),PASCAL,RAW,LONG
!  GdipCombineRegionRect             PROCEDURE( LONG ptrRegion, LONG ptrRectF, Enum:CombineMode CombineMd),PASCAL,RAW,LONG
!  GdipCombineRegionRectI            PROCEDURE( LONG ptrRegion, LONG ptrRectF, Enum:CombineMode CombineMd),PASCAL,RAW,LONG
!  GdipCombineRegionPath             PROCEDURE( LONG ptrRegion,  LONG ptrPath, Enum:CombineMode CombineMd),PASCAL,RAW,LONG
!  GdipCombineRegionRegion           PROCEDURE( LONG ptrRegion,  region2  Long, Enum:CombineMode CombineMd),PASCAL,RAW,LONG
!  GdipTranslateRegion               PROCEDURE( LONG ptrRegion,  SREAL dx,  SREAL dy),PASCAL,RAW,LONG
!  GdipTranslateRegionI              PROCEDURE( LONG ptrRegion,  LONG dx,  LONG dy),PASCAL,RAW,LONG
!  GdipTransformRegion               PROCEDURE( LONG ptrRegion,  LONG ptrMatrix  ),PASCAL,RAW,LONG
!  GdipGetRegionBounds               PROCEDURE( LONG ptrRegion, LONG ptrGraphics, LONG ptrRectF),PASCAL,RAW,LONG
!  GdipGetRegionBoundsI              PROCEDURE( LONG ptrRegion, LONG ptrGraphics, LONG ptrRectL),PASCAL,RAW,LONG
!  GdipGetRegionHRgn                 PROCEDURE( LONG ptrRegion, LONG ptrGraphics, LONG hRgn),PASCAL,RAW,LONG
!  GdipIsEmptyRegion                 PROCEDURE( LONG ptrRegion, LONG ptrGraphics, LONG Result),PASCAL,RAW,LONG
!  GdipIsInfiniteRegion              PROCEDURE( LONG ptrRegion, LONG ptrGraphics, LONG Result),PASCAL,RAW,LONG
!  GdipIsEqualRegion                 PROCEDURE( LONG ptrRegion,  region2  Long, LONG ptrGraphics, LONG Result),PASCAL,RAW,LONG
!  GdipGetRegionDataSize             PROCEDURE( LONG ptrRegion, bufferSize  Long),PASCAL,RAW,LONG

!  NOTE: The buffer parameter is treated as a byte array

!  GdipGetRegionData                 PROCEDURE( LONG ptrRegion, buffer  Any,  bufferSize  Long, sizeFilled  Long),PASCAL,RAW,LONG
!  GdipIsVisibleRegionPoint          PROCEDURE( LONG ptrRegion, SREAL x, SREAL y, LONG ptrGraphics, LONG Result),PASCAL,RAW,LONG
!  GdipIsVisibleRegionPointI         PROCEDURE( LONG ptrRegion, LONG x,  LONG y, LONG ptrGraphics, LONG Result),PASCAL,RAW,LONG
!  GdipIsVisibleRegionRect           PROCEDURE( LONG ptrRegion, SREAL x, SREAL y,  SREAL rWidth,  SREAL rHeight, LONG ptrGraphics, LONG Result),PASCAL,RAW,LONG
!  GdipIsVisibleRegionRectI          PROCEDURE( LONG ptrRegion, LONG x,  LONG y,  LONG rWidth,  LONG rHeight, LONG ptrGraphics, LONG Result),PASCAL,RAW,LONG
!  GdipGetRegionScansCount           PROCEDURE( LONG ptrRegion, Ucount  Long,  LONG ptrMatrix  ),PASCAL,RAW,LONG
!  GdipGetRegionScans                PROCEDURE( LONG ptrRegion, LONG ptrRectF, LONG countPoint,  LONG ptrMatrix  ),PASCAL,RAW,LONG
!  GdipGetRegionScansI               PROCEDURE( LONG ptrRegion, rects  RECTL, LONG countPoint,  LONG ptrMatrix  ),PASCAL,RAW,LONG

!-----------------------------------------------
! ImageAttributes APIs (ALL)
!-----------------------------------------------

!  GdipCreateImageAttributes         PROCEDURE(LONG ImageAttr),PASCAL,RAW,LONG
!  GdipCloneImageAttributes          PROCEDURE( LONG ImageAttr, cloneImageattr  Long),PASCAL,RAW,LONG
!  GdipDisposeImageAttributes        PROCEDURE( LONG ImageAttr),PASCAL,RAW,LONG
!  GdipSetImageAttributesToIdentity  PROCEDURE( LONG ImageAttr,  ClrAdjType  ColorAdjustType),PASCAL,RAW,LONG
!  GdipResetImageAttributes          PROCEDURE( LONG ImageAttr,  ClrAdjType  ColorAdjustType),PASCAL,RAW,LONG

!  NOTE: The colourMatrix and grayMatrix parameters expect a ColorMatrix structure or NULL

!  GdipSetImageAttributesColorMatrix PROCEDURE( LONG ImageAttr,  ClrAdjType  ColorAdjustType,  enableFlag  Long, colourMatrix  ColorMatrix, grayMatrix  Any,  flags  ColorMatrixFlags),PASCAL,RAW,LONG
!  GdipSetImageAttributesThreshold   PROCEDURE( LONG ImageAttr,  ClrAdjType  ColorAdjustType,  enableFlag  Long,  threshold  SREAL),PASCAL,RAW,LONG
!  GdipSetImageAttributesGamma       PROCEDURE( LONG ImageAttr,  ClrAdjType  ColorAdjustType,  enableFlag  Long,  gamma  SREAL),PASCAL,RAW,LONG
!  GdipSetImageAttributesNoOp        PROCEDURE( LONG ImageAttr,  ClrAdjType  ColorAdjustType,  enableFlag  Long),PASCAL,RAW,LONG
!  GdipSetImageAttributesColorKeys   PROCEDURE( LONG ImageAttr,  ClrAdjType  ColorAdjustType,  enableFlag  Long,  colorLow  Long,  colorHigh  Long),PASCAL,RAW,LONG
!  GdipSetImageAttributesOutputChannel PROCEDURE( LONG ImageAttr,  ClrAdjstType  ColorAdjustType,  enableFlag  Long,  channelFlags  ColorChannelFlags),PASCAL,RAW,LONG
!  GdipSetImageAttributesOutputChannelColorProfile PROCEDURE( LONG ImageAttr,  ClrAdjType  ColorAdjustType,  enableFlag  Long,  colorProfileFilename  String),PASCAL,RAW,LONG
!  GdipSetImageAttributesRemapTable  PROCEDURE( LONG ImageAttr,  ClrAdjType  ColorAdjustType,  enableFlag  Long,  mapSize  Long, map  ColorMap),PASCAL,RAW,LONG
!  GdipSetImageAttributesWrapMode    PROCEDURE( LONG ImageAttr,  wrap  WrapMode,  argb  Long,  bClamp  Long),PASCAL,RAW,LONG
!  GdipSetImageAttributesICMMode     PROCEDURE( LONG ImageAttr,  bOn  Long),PASCAL,RAW,LONG
!  GdipGetImageAttributesAdjustedPalette PROCEDURE( LONG ImageAttr, colorPal  ColorPalette,  ClrAdjType  ColorAdjustType),PASCAL,RAW,LONG

!-----------------------------------------------
! FontFamily Functions (ALL)
!-----------------------------------------------

GdipCreateFontFamilyFromName       PROCEDURE(LONG ptrFontName, LONG FontCollection, LONG ptrFontFamily),PASCAL,RAW,LONG

GdipDeleteFontFamily               PROCEDURE (LONG ptrFontFamily),PASCAL,RAW,LONG

!  GdipCloneFontFamily               PROCEDURE( fontFamily  Long, clonedFontFamily  Long),PASCAL,RAW,LONG
!  GdipGetGenericFontFamilySansSerif PROCEDURE(nativeFamily  Long),PASCAL,RAW,LONG
!  GdipGetGenericFontFamilySerif     PROCEDURE(nativeFamily  Long),PASCAL,RAW,LONG
!  GdipGetGenericFontFamilyMonospace PROCEDURE(nativeFamily  Long),PASCAL,RAW,LONG

!  NOTE: name must be LF_FACESIZE in length or less

!  GdipGetFamilyName                  PROCEDURE( family  Long,  name  String,  language  Integer),PASCAL,RAW,LONG
!  GdipIsStyleAvailable               PROCEDURE( family  Long,  style  Long, IsStyleAvailable  Long),PASCAL,RAW,LONG
!  GdipFontCollectionEnumerable       PROCEDURE( fontCollection  Long, LONG ptrGraphics, numFound  Long),PASCAL,RAW,LONG
!  GdipFontCollectionEnumerate        PROCEDURE( fontCollection  Long,  numSought  Long, gpfamilies  Long,  numFound  Long, LONG ptrGraphics),PASCAL,RAW,LONG
!  GdipGetEmHeight                    PROCEDURE( family  Long,  style  Long, EmHeight  Integer),PASCAL,RAW,LONG
!  GdipGetCellAscent                  PROCEDURE( family  Long,  style  Long, CellAscent  Integer),PASCAL,RAW,LONG
!  GdipGetCellDescent                 PROCEDURE( family  Long,  style  Long, CellDescent  Integer),PASCAL,RAW,LONG
!  GdipGetLineSpacing                 PROCEDURE( family  Long,  style  Long, LineSpacing  Integer),PASCAL,RAW,LONG

!-----------------------------------------------
! Font Functions (ALL)
!-----------------------------------------------

!  GdipCreateFontFromDC               PROCEDURE( hdc  Long, createdfont  Long),PASCAL,RAW,LONG
!  GdipCreateFontFromLogfontA         PROCEDURE( hdc  Long, logfont  LOGFONTA, createdfont  Long),PASCAL,RAW,LONG
!  GdipCreateFontFromLogfontW         PROCEDURE( hdc  Long, logfont  LOGFONTW, createdfont  Long),PASCAL,RAW,LONG

GdipCreateFont                     PROCEDURE(LONG ptrFontFamily, SREAL emSize, LONG FntStyle, LONG unit, LONG CreatedFont),PASCAL,RAW,LONG

!  GdipCloneFont                      PROCEDURE( curFont  Long, cloneFont  Long),PASCAL,RAW,LONG

GdipDeleteFont                     PROCEDURE(LONG ptrCurFont),PASCAL,RAW,LONG

!  GdipGetFamily                      PROCEDURE( curFont  Long, family  Long),PASCAL,RAW,LONG
!  GdipGetFontStyle                   PROCEDURE( curFont  Long, style  Long),PASCAL,RAW,LONG
!  GdipGetFontSize                    PROCEDURE( curFont  Long, Size  SREAL),PASCAL,RAW,LONG
!  GdipGetFontUnit                    PROCEDURE( curFont  Long, Enum:GpUnit Unit),PASCAL,RAW,LONG
!  GdipGetFontHeight                  PROCEDURE( curFont  Long, LONG ptrGraphics, SREAL rHeight),PASCAL,RAW,LONG
!  GdipGetFontHeightGivenDPI          PROCEDURE( curFont  Long,  dpi  SREAL, SREAL rHeight),PASCAL,RAW,LONG
!  GdipGetLogFontA                    PROCEDURE( curFont  Long, LONG ptrGraphics, logfont  LOGFONTA),PASCAL,RAW,LONG
!  GdipGetLogFontW                    PROCEDURE( curFont  Long, LONG ptrGraphics, logfont  LOGFONTW),PASCAL,RAW,LONG
!  GdipNewInstalledFontCollection     PROCEDURE(fontCollection  Long),PASCAL,RAW,LONG
!  GdipNewPrivateFontCollection       PROCEDURE(fontCollection  Long),PASCAL,RAW,LONG
!  GdipDeletePrivateFontCollection    PROCEDURE(fontCollection  Long),PASCAL,RAW,LONG
!  GdipGetFontCollectionFamilyCount   PROCEDURE( fontCollection  Long, numFound  Long),PASCAL,RAW,LONG
!  GdipGetFontCollectionFamilyList    PROCEDURE( fontCollection  Long,  numSought  Long, gpfamilies  Long, numFound  Long),PASCAL,RAW,LONG
!  GdipPrivateAddFontFile             PROCEDURE( fontCollection  Long,  filename  String),PASCAL,RAW,LONG
!  GdipPrivateAddMemoryFont           PROCEDURE( fontCollection  Long,  memory  Long,  length  Long),PASCAL,RAW,LONG

!-----------------------------------------------
! Text Functions (ALL)
!-----------------------------------------------

GdipDrawString                     PROCEDURE(LONG ptrGraphics, LONG ptrStr, LONG length, LONG  thefont, LONG ptrLayoutRect, LONG StringFormat, LONG ptrBrush),PASCAL,RAW,LONG

!  GdipMeasureString                  PROCEDURE(LONG ptrGraphics,  str  String,  length  Long,  thefont  Long, layoutRect  RECTF,  StringFormat  Long, boundingBox  RECTF, codepointsFitted  Long, linesFilled  Long),PASCAL,RAW,LONG
!  GdipMeasureCharacterRanges         PROCEDURE(LONG ptrGraphics,  str  String,  length  Long,  thefont  Long, layoutRect  RECTF,  StringFormat  Long,  regionCount  Long, regions  Long),PASCAL,RAW,LONG
!  GdipDrawDriverString               PROCEDURE(LONG ptrGraphics,  str  String,  length  Long,  thefont  Long,  LONG ptrBrush, positions  POINTF,  flags  Long,  LONG ptrMatrix  ),PASCAL,RAW,LONG
!  GdipMeasureDriverString            PROCEDURE(LONG ptrGraphics,  str  String,  length  Long,  thefont  Long, positions  POINTF,  flags  Long,  LONG ptrMatrix  , boundingBox  RECTF),PASCAL,RAW,LONG

!-----------------------------------------------
! String format Functions (ALL)
!-----------------------------------------------

GdipCreateStringFormat                PROCEDURE(LONG formatAttributes, USHORT language, LONG ptrStringFormat),PASCAL,RAW,LONG

GdipStringFormatGetGenericDefault     PROCEDURE(LONG ptrStringFormat),PASCAL,RAW,LONG
GdipStringFormatGetGenericTypographic PROCEDURE(LONG ptrStringFormat),PASCAL,RAW,LONG
GdipDeleteStringFormat                PROCEDURE(LONG ptrStringFormat),PASCAL,RAW,LONG

GdipCloneStringFormat                 PROCEDURE(LONG ptrStringFormat, LONG newFormat),PASCAL,RAW,LONG
GdipSetStringFormatFlags              PROCEDURE(LONG ptrStringFormat, LONG flags),PASCAL,RAW,LONG
GdipGetStringFormatFlags              PROCEDURE(LONG ptrStringFormat, LONG flags),PASCAL,RAW,LONG

GdipSetStringFormatAlign              PROCEDURE(LONG ptrStringFormat, LONG StringAlignment),PASCAL,RAW,LONG
GdipGetStringFormatAlign              PROCEDURE(LONG ptrStringFormat, LONG ptrStringAlignment),PASCAL,RAW,LONG

GdipSetStringFormatLineAlign          PROCEDURE(LONG ptrStringFormat, LONG StringAlignment),PASCAL,RAW,LONG
GdipGetStringFormatLineAlign          PROCEDURE(LONG ptrStringFormat, LONG ptrStringAlignment),PASCAL,RAW,LONG

GdipSetStringFormatTrimming           PROCEDURE(LONG ptrStringFormat, LONG StringTrimming),PASCAL,RAW,LONG
GdipGetStringFormatTrimming           PROCEDURE(LONG ptrStringFormat, LONG trimming),PASCAL,RAW,LONG

!  GdipSetStringFormatHotkeyPrefix    PROCEDURE(LONG ptrStringFormat,  hkPrefix  HotkeyPrefix),PASCAL,RAW,LONG
!  GdipGetStringFormatHotkeyPrefix    PROCEDURE(LONG ptrStringFormat, hkPrefix  HotkeyPrefix),PASCAL,RAW,LONG

!  GdipSetStringFormatTabStops        PROCEDURE(LONG ptrStringFormat,  firstTabOffset  SREAL,  LONG countPoint, tabStops  SREAL),PASCAL,RAW,LONG
!  GdipGetStringFormatTabStops        PROCEDURE(LONG ptrStringFormat,  LONG countPoint, firstTabOffset  SREAL, tabStops  SREAL),PASCAL,RAW,LONG
!  GdipGetStringFormatTabStopCount    PROCEDURE(LONG ptrStringFormat, LONG countPoint),PASCAL,RAW,LONG

!  GdipSetStringFormatDigitSubstitution PROCEDURE(LONG ptrStringFormat,  language  Integer,  substitute  StringDigitSubstitute),PASCAL,RAW,LONG
!  GdipGetStringFormatDigitSubstitution PROCEDURE(LONG ptrStringFormat, language  Integer, substitute  StringDigitSubstitute),PASCAL,RAW,LONG

!  GdipGetStringFormatMeasurableCharacterRangeCount PROCEDURE(LONG ptrStringFormat, LONG countPoint),PASCAL,RAW,LONG
!  GdipSetStringFormatMeasurableCharacterRanges     PROCEDURE(LONG ptrStringFormat,  rangeCount  Long, ranges  CharacterRange),PASCAL,RAW,LONG

    END
  END

!-----------------------------------------------
  _EndOfInclude_
